Unit UProject;

interface

procedure BuildTree(sIn: string; Root: TBTree);


implementation


{****************** Zsobnk *********************}

type
    { ADT zsobnk implementovan linernm seznamem }
    TStack = ^TElement;         { reprezentace ADT zsobnk }
    TElement = record            { prvek seznamu/zsobnku   }
        ch : char;                { uiten obsah            }
        ptr : TStack;            { zetzen poloek         }
        end;


procedure StackInit (var S : TStack);
begin
    S := nil;
end;


function StackEmpty (S : TStack) : boolean;
begin
    StackEmpty := S = nil;
end;


function Top (var S : TStack) : char;
begin
    if not StackEmpty(S) then Top := S^.ch;
end;


function TopPop (var S : TStack) : char;
var
    ptr: TStack;
begin
    if not StackEmpty(S) {zsobnk nen przdn} then begin
        TopPop := S^.ch; {zkopruje uitenou hodnotu}

        {odstrann prvnho prvku seznamu}
        ptr := S;
        S := ptr^.ptr;
        Dispose(ptr);
        end;
end;


procedure Push (var S : TStack; ch : char);
var
    ptr: TStack;
begin
    {vloen novho prvku na zatek seznamu}
    New(ptr);
    ptr^.ptr := S;
    S := ptr;

    S^.ch := ch; {uloen uiten hodnoty}
end;


{******************* Binrn strom *********************}

type
    TNodePtr = ^TNode;     { typ ukazatel na uzel }
    TNode = record          { uzel stromu }
        Cont : Longint;      { obsah uzlu  }
        LPtr : TNodePtr;    { ukazatel na lev podstrom  }
        RPtr : TNodePtr;    { ukazatel na prav podstrom }
        end;

procedure BTInit (var RootPtr : TNodePtr);
begin
    RootPtr := nil;
end;


procedure BTInsert (var RootPtr : TNodePtr; Content : integer);
begin
    if RootPtr = nil {strom je przdn} then begin
        New(RootPtr);{alokace pamti pro koen}
        RootPtr^.Cont := Content;
        RootPtr^.LPtr := nil;
        RootPtr^.RPtr := nil;
        end
    else if Content <= RootPtr^.Cont then
        BTInsert(RootPtr^.LPtr, Content) {vloen do levho podstromu}
    else
        BTInsert(RootPtr^.RPtr, Content);{vloen do pravho podstromu}
end;


procedure BTDeleteLR (var RootPtr : TNodePtr; Content : integer);
begin
    if RootPtr <> nil then begin {(RootPtr=nil) ukon rekurzivn voln
                                 v ppad, e obsah nebyl ve stromu nalezen}
        if RootPtr^.Cont = Content then begin
            if RootPtr^.LPtr <> nil then {zru lev podstrom}
                BTDeleteLR(RootPtr^.LPtr, RootPtr^.LPtr^.Cont);
            if RootPtr^.RPtr <> nil then {zru prav podstrom}
                BTDeleteLR(RootPtr^.RPtr, RootPtr^.RPtr^.Cont);
            Dispose(RootPtr); {uvolnn pamti obsahujc koen}
            RootPtr := nil;
            end
        else if Content < RootPtr^.Cont then {hledej dl v levm podstromu}
            BTDeleteLR(RootPtr^.LPtr, Content)
        else {hledej dl v pravm podstromu}
            BTDeleteLR(RootPtr^.RPtr, Content);
        end;
end;


procedure BTPreOrder (RootPtr : TNodePtr);
begin
    if RootPtr <> nil {(RootPtr=nil) ukon rekurzivn voln} then begin
        BTWorkOut(RootPtr);
        BTPreOrder(RootPtr^.LPtr);
        BTPreOrder(RootPtr^.RPtr);
        end;
end;


procedure BTInOrder (RootPtr : TNodePtr);
begin
    if RootPtr <> nil {(RootPtr=nil) ukon rekurzivn voln} then begin
        BTInOrder(RootPtr^.LPtr);
        BTWorkOut(RootPtr);
        BTInOrder(RootPtr^.RPtr);
        end;
end;


procedure BTPostOrder (RootPtr : TNodePtr);
begin
    if RootPtr <> nil {(RootPtr=nil) ukon rekurzivn voln} then begin
        BTPostOrder(RootPtr^.LPtr);
        BTPostOrder(RootPtr^.RPtr);
        BTWorkOut(RootPtr);
        end;
end;


procedure BTDisposeTree (var RootPtr : TNodePtr);
begin
    if RootPtr <> nil {(RootPtr=nil) ukon rekurzivn voln} then begin
        BTDisposeTree(RootPtr^.LPtr); {uvoln z pamti lev podstrom}
        BTDisposeTree(RootPtr^.RPtr); {uvoln z pamti prav podstrom}
        Dispose(RootPtr); {uvoln pam؜ obsazenou koenem}
        RootPtr := nil;
        end;
end;


{************************ prevod do postfixu ****************************}


procedure Infix2Postfix (var fin, fout : text);
var
    s: TLStack;
    c: Char;
    RowCount, CharCount: Integer;

procedure UntilLPar (var s : tLStack);
var
    c: Char;
begin
    c := LTopPop(s);
    while c <> '(' do begin
        Write(fout, c);
        c := LTopPop(s);
        end;
end;


procedure DoOperation (var s : tLStack; c : char);
    function CanPush(s: TLStack; c: Char): Boolean;
    {vrac True, pokud je mono vloit opertor do zsobnku}
    begin
        if LStackEmpty(s) then
            CanPush := True {do przdnho zsobnku lze vloit vdy}
        else
            if c in ['*', '/'] {opertor s vy prioritou} then
                CanPush := not (LTop(s) in ['*', '/'])
                    {nelze vloit na opertor se stejnou prioritou}
            else
                CanPush := not (LTop(s) in ['+', '-', '*', '/']);
                    {nelze vloit na opertor s vy ani stejnou prioritou}
    end;
begin
    while not CanPush(s, c) {dokud nelze opertor vloit} do
        Write(fout, LTopPop(s)); {vrchol zsobnku opsat do souboru}
    LPush(s, c);
end;

begin
    LStackInit(s); {inicializace zsobnku}
    LPush(s, '(');

    RowCount := 0; {iniciaizace potu dk v souboru}
    CharCount := 0; {inicializace potu znak v souboru}
    while not Eof(fin) do begin
        {zatek dku}
        RowCount := Succ(RowCount);
        while not Eoln(fin) do begin
            CharCount := Succ(CharCount);
            Read(fin, c);
            {zpracovn znaku}
            if c in ['+', '-', '*', '/'] {opertor} then
                DoOperation(s, c)
            else if c = '(' then
                LPush(s, c)
            else if c = ')' then
                UntilLPar(s)
            else if not (c = ' ') {vynechn mezer} then
                Write(fout, c);
            end;
        {konec dku}
        ReadLn(fin);
        end;
    UntilLPar(s);
    WriteLn(fout);
    WriteLn(fout, RowCount);
    WriteLn(fout, CharCount);
end;
