{ Zdrojov soubor /courses/ADS/private/sbirka/intrpret.skl
modifikovn skriptem novyukol.pl }
{ intrpret.pas: Hlavn modul interpretu pedpis pro testovn
                poadovanho chovn implementace een kolu.

Od z 1997 soust systmu SOVA. Do uvedenho data soust systmu OSYS.
Copyright (C) 1994-1998, Petr Pikryl <prikryl@dcse.fee.vutbr.cz>


Historie:
---------
   1.4.1998 - zavedena procedura CommandCloseInput a odpovdajc
              pkaz interpretu
  18.3.1998 - neznm pkaz se nyn vypisuje v apostrofech; obdobn se
              vypisuje i comstr (zbytek dku)
   5.3.1998 - zaveden pkaz DataEol
   2.2.1998 - opt zaveden vpis hodnoty v HeapMark -- viz poznmka na mst.
   2.1.1998 - v pkazu HeapMark se nyn nevypisuje hodnota, ke
              kter se budou vztahovat relativn daje o spoteb Heap
   1.1.1998 - odstrann pkaz interpretu `Difficulty' a odpovdajc
              procedura CommandDifficulty.
            - implicitn jmno hlavnho skriptu zmnno ze `script'
              na intrpret.scr
            - prava identifikace dku pro vkldn rozen
              interpretu
  1.12.1997 - upraveno generovn intrpret.pas pi zveejovn
              novho kolu. Kostra (skeleton) interpretu uloena
              do souboru intrpret.skl. Generovn intrpret.pas
              se provd perl-skriptem, kter pmo do skeletonu
              vkld potebn doplky souvisejc se zadanmi
              pklady kolu => redukce potu soubor, zobecnn
              na libovoln poet pklad kolu.
 listopad 1994 - verze 1.1 (soubor intrpret.pas)
}

{$M 64000,50000,200000} {= stack size, heap min, heap max}

uses DOS, Crt, UkolX;   { modul UkolX je hlavnm modulem eenho kolu}

{--------------------------------------------------------------------}
{ vnitn konstanty a typy interpretu }
const
    COMMENTCH = '%';     { comment to the end of line }
    IMPLICIT_LOG_NAME = 'logfile';    { implicitn jmno log-souboru }
    SSTRING_LEN = 30;    { dlka krtkho etzce (mus bt alespo 13
                           kvli ukldn jmna souboru) }
type
    tShortString = string[SSTRING_LEN];  { krtk etzec }
    tScriptStatusPtr = ^tScriptStatus;
    tScriptStatus = record   { zznam o odloenm skriptu (nvratov adresa) }
        script_name : tShortString;  { jmno souboru se skriptem   }
        script_lnum : integer;       { poet zpracovanch dk    }
        next : tScriptStatusPtr;     { ukazatel na dal zznam    }
        end;

{******* Globln promnn a standardn funkce interpretu pklad *******}
var
    main_script_name : string; { jmno hlavnho skriptu }
    fscript     : text;      { textov soubor s interpretovanm skriptem }
    script_path : string;    { cesta ke vem skriptm (krom hlavnho) }
    script_name : string;    { jmno souboru se skriptem          }
    script_lnum : integer;   { slo aktulnho dku ze skriptu  }
    script_stack : tScriptStatusPtr; { zsobnk nvratovch adres }
    log_name    : string;      { jmno log-souboru      }
    flog        : text;        { log-soubor             }
    datafile_name : string;    { jmno datovho souboru }
    fdata       : text;        { datov soubor          }
    beep_times  : integer;     { maximln poet ppnut za program    }
    quit_interpret : boolean;  { pznak poadavku ukonen interpretu }

    { Nsledujc globln promnn interptretu jsou uren pro pedvn
      hodnot pslunho typu mezi rznmi pkazy.  Nepouvaj se jako
      pomocn promnn. }
    int_val     : integer; { globln promnn interpretu typu integer }
    str_val     : string;  { globln promnn interpretu typu string  }
    bool_val    : boolean; { globln promnn interpretu typu boolean }
    mark_heap   : longint; { relativn hranice pouvanho prostoru v Heap }
    heap_size   : longint; { celkov velikost Heap }

    input_name  : string;  { jmno vstupnho textovho souboru fin  }
    output_name : string;  { jmno vstupnho text. souboru fout    }
  { Vstupn textov soubor fin:text a vstupn textov soubor
    fout:text jsou deklarovny na zatku programu jako globln,
    viditeln pro vechy een pklady.  Jmna tchto soubor lze zadvat
    s plnou cestou. }
    stdout : text;         { kvli Crt, aby fungovalo pesmrovn }

    GetErrorFlag : char;   { nastavuje se pi chyb v procedurch Get?val:
                               ' ' ... bez chyby
                               '?' ... chyba pi Get?val (velk psmeno) }

{-----------------------------------------------------------------------}

{ prce se vstupem (soubor fin) }
procedure CommandAssignInput (name:string);                  forward;
procedure CommandResetInput;                                 forward;
procedure CommandCloseInput;                                 forward;

{ prce s vstupem (soubor fout) }
procedure CommandAssignOutput (name:string);                 forward;
procedure CommandRewriteOutput;                              forward;
procedure CommandAppendOutput;                               forward;
procedure CommandMsg (s:string);                             forward;
procedure CommandMsgnoln (s:string);                         forward;

{ prce s obecnm datovm souborem (generovn vstupnch textovch dat) }
procedure CommandAssignDataFile(name:string);                forward;
procedure CommandEraseDataFile;                              forward;
procedure CommandDataln (s:string);                          forward;
procedure CommandData (s:string);                            forward;

{ prce s log-souborem (ladn, registrace chyb,...) }
procedure CommandAssignLogFile (name:string);                forward;
procedure CommandEraseLogFile;                               forward;
procedure CommandLog (s:string);                             forward;

{ miscelaneous }
procedure Imsg (msg:string);                                 forward;
procedure CommandBeep;                                       forward;
procedure CommandConsole (s:string);                         forward;
procedure CommandEraseFile (s:string);                       forward;
procedure CommandCommand (s:string);                         forward;

{ prce s uvedenm skriptem }
procedure CommandScript (name:string);                       forward;
procedure CommandScriptPath (s:string);                      forward;
procedure CommandReturn;                                     forward;
procedure CommandQuit;                                       forward;

{ konstrukce }
procedure CommandFor (ch:char; i,j:integer; comstr:string);  forward;
procedure CommandForDown (ch:char; i,j:integer; comstr:string);  forward;
procedure CommandForEnum (ch:char; var enum:string; comstr:string);  forward;

{ natn parametr pkaz }
function  GetError : boolean;                                forward;
procedure GetSval (var getstr:string; var sval:string);      forward;
procedure GetIval (var getstr:string; var ival:integer);     forward;
procedure GetCval (var getstr:string; var ch:char);          forward;
procedure GetRval (var getstr:string; var rval:real);        forward;

{ pomocn procedury a funkce }
procedure InitGlobVar;                                       forward;
procedure trim (var s:string);                               forward;
function  OpenScript : boolean;                              forward;

{ due a tlo interpretu }
procedure SeparateCommand (var comstr:string; var comm:tShortString); forward;
procedure command (var comstr:string);                       forward;
procedure Interpret (scr_name:tShortString);                 forward;



{ *** Rozen interpretu pro konkrtn pklady ***}
{ p201.iex: Implementace nestandardnch funkc interpretu specilnch
            pkaz k pkladu }

var
    LList : tList;       { pro testovn }
    LLobsah : tStr;


procedure PrintLList (L:tList);
{         ----------
  Vytiskne obsah a aktivitu seznamu do souboru fout. Tento zpis je
  schvln trochu komplikovan a netypick, aby na prvn pohled
  nenapovdal, jak by mla bt eena tla procedur a funkci implementovan
  v rmci een kolu }
begin
    WriteLn(fout,'---------------------');
    while L.first<>nil do
        begin
        Write(fout,'''',L.first^.s,'''');
        if L.first=L.act then
            WriteLn(fout,' ':SizeOf(tStr)-Length(L.first^.s)-2,'<== ACT')
        else WriteLn(fout);
        L.first:=L.first^.ptr;
        end;
    WriteLn(fout,'---------------------');
end;   { PrintLList }


function specialP201 (var comm:tShortString; var comstr:string):boolean;
var s : string;
begin
    specialP201 := true;                 { init }
    errflg := false;               { init - dn oetovan chyba }
    LLobsah := 'UNDEFINED';                   { init }

    if      comm='PRINT:LLIST' then begin
        WriteLn(fout, 'Obsah seznamu LList:');
        PrintLList(LList);
        Writeln(fout);
        end
    else if comm='INITLIST:LLIST' then begin
        WriteLn(fout, 'Operace InitList(LList)');
        InitList(LList);
        PrintLList(LList);
        WriteLn(fout);
        end
    else if comm='DISPOSELIST:LLIST' then begin
        WriteLn(fout, 'Operace DisposetList(LList)');
        DisposeList(LList);
        PrintLList(LList);
        WriteLn(fout);
        end
    else if comm='INSERTFIRST:LLIST' then begin
        GetSval(comstr,s);
        if not GetError then begin
            WriteLn(fout, 'Operace InsertFirst(LList, ''',s,''')');
            InsertFirst(LList,s);
            PrintLList(LList);
            WriteLn(fout);
            end;
        end
    else if comm='COPYFIRST:LLIST' then begin
        CopyFirst(LList,LLobsah);
        Write(fout, 'Operace CopyFirst(LList, Obsah) ');
        if not errflg then WriteLn(fout, 'vrac Obsah = ''',LLobsah,'''')
        else               WriteLn(fout, 'volala proceduru ERROR');
        WriteLn(fout);
        end
    else if comm='DELETEFIRST:LLIST' then begin
        WriteLn(fout, 'Operace DeleteFirst(LList)');
        DeleteFirst(LList);
        PrintLList(LList);
        WriteLn(fout);
        end
    else if comm='ACTIVE:LLIST' then begin
        WriteLn(fout, 'Operace Active(LList) vrac ', Active(LList));
        WriteLn(fout);
        end
    else if comm='FIRST:LLIST' then begin
        WriteLn(fout, 'Operace First(LList)');
        First(LList);
        PrintLList(LList);
        WriteLn(fout);
        end
    else if comm='LCOPY:LLIST' then begin
        LCopy(LList,LLobsah);
        Write(fout, 'Operace LCopy(LList, Obsah) ');
        if not errflg then WriteLn(fout, 'vrac Obsah = ''',LLobsah,'''')
        else               WriteLn(fout, 'volala proceduru ERROR');
        WriteLn(fout);
        end
    else if comm='LSUCC:LLIST' then begin
        WriteLn(fout, 'Operace LSucc(LList)');
        LSucc(LList);
        PrintLList(LList);
        WriteLn(fout);
        end
    else if comm='ACTUALIZE:LLIST' then begin
        GetSval(comstr,s);
        if not GetError then begin
            WriteLn(fout, 'Operace Actualize(LList, ''',s,''')');
            Actualize(LList,s);
            PrintLList(LList);
            WriteLn(fout);
            end;
        end
    else if comm='POSTDELETE:LLIST' then begin
        WriteLn(fout, 'Operace PostDelete(LList)');
        PostDelete(LList);
        PrintLList(LList);
        WriteLn(fout);
        end
    else if comm='POSTINSERT:LLIST' then begin
        GetSval(comstr,s);
        if not GetError then begin
            WriteLn(fout, 'Operace PostInsert(LList, ''',s,''')');
            PostInsert(LList,s);
            PrintLList(LList);
            WriteLn(fout);
            end;
        end
    else specialP201 := false;   { nenalezen vhodn pkaz }
end;
{ p202.iexS: Implementace nestandardnch funkc interpretu
             pkaz k pkladu. }

var
    LStack : tLStack;      { pro testy operac se zsobnkem }
    AStack : tAStack;      { pro testy operac se zsobnkem }


procedure LStackPrint (S : tLStack);
{         -----------
  Vytiskne stav zsobnku. (Nekomentovno schvln) }
var
    cnt : integer;          { counter [kauntr] = potadlo }

begin
    cnt := 0;
    write(fout,'Top [ ');
    while S<>nil do begin
        write(fout,S^.ch,' ');
        S:=S^.ptr;
        cnt := cnt+1;
        if (cnt mod 32) = 0 then begin
            writeln(fout);
            write(fout,'      ');
            end;
        end;
    writeLn(fout,']');
end;


procedure AStackPrintInit (var S : tAStack);
{         ---------------
  Simuluje nedefinovan hodnoty ADT zsobnk. }
var i : integer;
begin
    for i:=1 to MAX_ASTACK do S.arr[i]:='?';
    S.top := 5;
end;


procedure AStackUndef (var S : tAStack);
{         -----------
  Simuluje nedefinovan hodnoty v nevyuvan sti zsobnku. }
var i : integer;
begin
    for i:=1 to MAX_ASTACK do  if i>S.top then S.arr[i]:='X';
end;


procedure AStackPrint (var S : tAStack);
{         -----------
  Tisk obsahu zsobnku. }
var i : integer;
begin
    AStackUndef(S);
    write(fout,' ');
    for i:=1 to AStackSize do write(fout, S.arr[i]);
    writeln(fout,'  AStackSize = ', AStackSize);
    if S.top>AStackSize then
        writeln(fout,'Vrchol (index) mimo povolen rozsah: ',S.top)
    else begin
        write(fout,' ');
        for i:=0 to S.top-1 do write(fout,' ');
        writeln(fout,'T');
        end;
end;


function specialP202 (var comm:tShortString; var comstr:string):boolean;
var
    i : integer;
    s : string;
    ch : char;
begin
    specialP202 := true;                 { init }
    errflg := false;
    if comm='LSTACKPRINT' then begin
        WriteLn(fout, 'Obsah zsobnku: ');
        LStackPrint(LStack);
        WriteLn(fout);
        end
    else if comm='LSTACKINIT' then begin
        WriteLn(fout, 'Operace LStackInit(LStack)');
        LStackInit(LStack);
        LStackPrint(LStack);
        WriteLn(fout);
        end
    else if comm='LPUSH' then begin
        GetSval(comstr,s);
        ch := '?';
        if not GetError then begin
            if (length(s)=0) or (length(s)>1) then
                Imsg(' LPush - oekv se jednoznakov etzec')
            else ch:=s[1];
            WriteLn(fout, 'Operace LPush(LStack, ''', ch, ''')');
            LPush(LStack,ch);
            LStackPrint(LStack);
            WriteLn(fout);
            end;
        end
    else if comm='LTOPPOP' then begin
        ch := LTopPop(LStack);
        Write(fout, 'Operace LTopPop(LStack) ');
        if not errflg then WriteLn(fout, 'vrac hodnotu ''', ch, '''')
        else               WriteLn(fout, 'volala proceduru StackError');
        LStackPrint(LStack);
        WriteLn(fout);
        end
    else if comm='LTOP' then begin
        ch := LTop(LStack);
        Write(fout, 'Operace LTop(LStack) ');
        if not errflg then WriteLn(fout, 'vrac hodnotu ''', ch, '''')
        else               WriteLn(fout, 'volala proceduru StackError');
        WriteLn(fout);
        end
    else if comm='LSTACKEMPTY' then begin
        Writeln(fout, 'Operace LStackEmpty(LStack) vrac hodnotu ',
                      LStackEmpty(LStack));
        WriteLn(fout);
        end
    {-------------------------------------------------------------------}
    else if comm='ASTACKSIZE' then begin
        GetIval(comstr,i);
        if not GetError then begin
            if i<1 then i:=1
            else if i>MAX_ASTACK then i:=MAX_ASTACK;
            AStackSize := i;
            end;
        end
    else if comm='ASTACKPRINTINIT' then AStackPrintInit(AStack)
    else if comm='ASTACKPRINT' then begin
        WriteLn(fout, 'Obsah zsobnku: ');
        AStackPrint(AStack);
        WriteLn(fout);
        end
    else if comm='ASTACKINIT' then begin
        WriteLn(fout, 'Operace AStackInit(AStack)');
        AStackInit(AStack);
        AStackPrint(AStack);
        WriteLn(fout);
        end
    else if comm='APUSH' then begin
        GetSval(comstr,s);
        ch := '?';
        if not GetError then begin
            if (length(s)=0) or (length(s)>1) then
                Imsg(' APush - oekv se jednoznakov etzec')
            else ch:=s[1];
            WriteLn(fout, 'Operace APush(AStack, ''', ch, ''')');
            APush(AStack,ch);
            if errflg then
                WriteLn(fout, 'Operace APush volala proceduru StackError');
            AStackPrint(AStack);
            WriteLn(fout);
            end;
        end
    else if comm='ATOPPOP' then begin
        ch := ATopPop(AStack);
        Write(fout, 'Operace ATopPop(AStack) ');
        if not errflg then WriteLn(fout, 'vrac hodnotu ''', ch, '''')
        else               WriteLn(fout, 'volala proceduru StackError');
        AStackPrint(AStack);
        WriteLn(fout);
        end
    else if comm='ATOP' then begin
        ch := ATop(AStack);
        Write(fout, 'Operace ATop(AStack) ');
        if not errflg then WriteLn(fout, 'vrac hodnotu ''', ch, '''')
        else               WriteLn(fout, 'volala proceduru StackError');
        WriteLn(fout);
        end
    else if comm='ASTACKEMPTY' then begin
        Writeln(fout, 'Operace AStackEmpty(AStack) vrac hodnotu ',
                      AStackEmpty(AStack));
        WriteLn(fout);
        end
    else if comm='ASTACKFULL' then begin
        Writeln(fout, 'Operace AStackFull(AStack) vrac hodnotu ',
                      AStackFull(AStack));
        WriteLn(fout);
        end
    else specialP202 := false;   { nenalezen vhodn pkaz }
end;

{ p203.iex: Implementace nestandardnch funkc interpretu pkaz k pkladu }

var
    Queue : tQueue;  { pro testovn }


procedure QueuePrintInit (var Q : tQueue);
{         --------------
  Simuluje nedefinovan hodnoty ADT fronta. }
var i : integer;
begin
    for i:=0 to QUEMAX do Q.qa[i]:='?';
    Q.FrontIndex := 5;
    Q.BackIndex  := 12;
    QueSize := QUEMAX div 2;
end;



procedure QueuePrint (Q : tQueue; Size : integer);
{         ----------
  Tisk fronty - nekomentovno zmrn. }
var
    i : integer;
    ch : char;
begin
    for i:=0 to Size do write(fout, '-');
    writeln(fout);

    for i:=0 to Size do write(fout, Q.qa[i]);
    writeln(fout,'   QueSize = ', QueSize);

    for i:=0 to Size do begin
        ch := ' ';
        if (i=Q.FrontIndex) or (i=Q.BackIndex) then ch := '^';
        write(fout, ch);
        end;
    WriteLn(fout);

    for i:=0 to Size do
        if (i=Q.FrontIndex) and (i=Q.BackIndex) then  write(fout,'E')
        else if i=Q.FrontIndex then                   write(fout,'F')
        else if i=Q.BackIndex then                    write(fout,'B')
        else                                          write(fout,' ');

    writeln(fout);
end;


function specialP203 (var comm:tShortString; var comstr:string):boolean;
var
    s : string;
    ch : char;
    i : integer;
begin
    specialP203 := true;                 { init }
    errflg := false;
    if comm='QUEUESIZE' then begin
        WriteLn(fout, 'U ADT fronta jsou simulovny nedefinovan hodnoty.');
        QueuePrintInit(Queue);
        WriteLn(fout, 'Simulovan obsah datovch struktur vypad takto:');
        QueuePrint(Queue, QUEMAX);
        WriteLn(fout);

        GetIval(comstr,i);
        if not GetError then QueSize:=i;
        WriteLn(fout, 'Simulovan horn index pole pro frontu (QueSize) byl ',
                      'nastaven na hodnotu ', QueSize);
        QueuePrint(Queue, QueSize);
        WriteLn(fout);
        end
    else if comm='QUEUEPRINT' then begin
        WriteLn(fout, 'Obsah fronty:');
        QueuePrint(Queue, QueSize);
        WriteLn(fout);
        end
    else if comm='QUEUEINIT' then begin
        WriteLn(fout, 'Operace QueueInit(Queue)');
        QueueInit(Queue);
        QueuePrint(Queue, QueSize);
        WriteLn(fout);
        end
    else if comm='QUEUEEMPTY' then begin
        WriteLn(fout, 'Operace QueueEmpty(Queue) vrac hodnotu ',
                      QueueEmpty(Queue));
        WriteLn(fout);
        end
    else if comm='QUEUEFULL' then begin
        WriteLn(fout, 'Operace QueueFull(Queue) vrac hodnotu ',
                      QueueFull(Queue));
        WriteLn(fout);
        end
    else if comm='QUEUEUP' then begin
        GetSval(comstr,s);
        ch := '?';
        if not GetError then begin
            if (length(s)=0) or (length(s)>1) then
                Imsg(' QueueUp - oekv se jednoznakov etzec.')
            else ch:=s[1];
            WriteLn(fout, 'Operace QueueUp(Queue, ''', ch, ''')');
            QueueUp(Queue,ch);
            if errflg then WriteLn(fout,
                           'Operace QueueUp volala proceduru QueueError');
            QueuePrint(Queue, QueSize);
            WriteLn(fout);
            end;
        end
    else if comm='QUEUEFRONT' then begin
        ch := QueueFront(Queue);
        Write(fout, 'Operace QueueFront(Queue) ');
        if not errflg then WriteLn(fout, 'vrac hodnotu ''', ch, '''')
        else               WriteLn(fout, 'volala proceduru QueueError');
        WriteLn(fout);
        end
    else if comm='QUEUEREMOVE' then begin
        QueueRemove(Queue);
        Write(fout, 'Operace QueueRemove(Queue)');
        if errflg then WriteLn(fout, 'volala proceduru QueueError')
        else WriteLn(fout);
        QueuePrint(Queue, QueSize);
        WriteLn(fout);
        end
    else if comm='QUEUEGET' then begin
        ch := QueueGet(Queue);
        Write(fout, 'Operace QueueGet(Queue) ');
        if not errflg then WriteLn(fout, 'vrac hodnotu ''', ch, '''')
        else               WriteLn(fout, 'volala proceduru QueueError');
        QueuePrint(Queue, QueSize);
        WriteLn(fout);
        end
    else specialP203 := false;   { nenalezen vhodn pkaz }
end;

{ p204.iex: Implementace nestandardnch funkc interpretu
            pkaz k pkladu }



function specialP204 (var comm:tShortString; var comstr:string):boolean;
var i : integer;
begin
    specialP204 := true;                 { init }
    if comm='INFIX2POSTFIX' then Infix2Postfix(fin,fout)
    else specialP204 := false;   { nenalezen vhodn pkaz }
end;



{************************* Funkce Interpretu *****************************}

{ prce se vstupem (soubor fin) ==========================================}

procedure CommandAssignInput (name:string);
{         ------------------
  Piad logickmu (globlnmu) souboru fin fyzick jmno 'name'.
  Jmno me obsahovat i plnou cestu k souboru.
  Soubor fin nesm bt oteven. }
var i : integer;
begin
    input_name := name;
    {$I-} close(fin); {$I+}    { zaveme, pokud byl oteven }
    i := IOResult;             { shodme intern pznak }
    {$I-} assign(fin,input_name); {$I+}
    if IOResult<>0 then
        Imsg('Nespn operace AssignInput '''+name+'''');
end;


procedure CommandResetInput;
{         -----------------
  Oteven souboru fin pro ten. }
begin
    {$I-} reset(fin); {$I+}
    if IOResult<>0 then begin
        Imsg('Nespn proveden pkazu ResetInput.');
        Imsg(' Existuje soubor '''+input_name+'''?');
        Imsg(' Byl ped ResetInput proveden pkaz AssignInput?');
        end;
end;


procedure CommandCloseInput;
{         -----------------
  Uzaven souboru fin -- napklad ped maznm souboru ped generovnm
  novho obsahu (EraseDataFile). }
var i : integer;
begin
    {$I-} close(fin); {$I+}
    i := IOResult;
end;


{ prce s vstupem (soubor fout) =========================================}

procedure CommandAssignOutput (name:string);
{         -------------------
  Piad logickmu (globlnmu) souboru fout fyzick jmno 'name'.
  Jmno me obsahovat i plnou cestu k souboru.
  Soubor fout nesm bt oteven. }
var i : integer;
begin
    output_name := name;
    {$I-} close(fout); {$I+}   { zaveme, pokud byl oteven }
    i := IOResult;             { shodme intern pznak }
    {$I-} assign(fout,output_name); {$I+}
    if IOResult<>0 then
        Imsg('Nespn operace AssignOutput '''+name+'''');
end;


procedure CommandRewriteOutput;
{         --------------------
  Oteven souboru fout pro zpis. }
var i : integer;
begin
    {$I-} close(fout); {$I+}   { nkdo mohl zapomenout zavt soubor }
    i := IOResult;             { shodme intern pznak }
    {$I-} rewrite(fout); {$I+}
    if IOResult<>0 then begin
        Imsg('Nespn proveden pkazu RewriteOutput.');
        Imsg(' Lze vytvoit soubor '''+input_name+'''?');
        Imsg(' Byl ped RewriteOutput proveden pkaz AssignOutput?');
        end;

end;


procedure CommandAppendOutput;
{         -------------------
  Oteven souboru fout pro zpis na konec souboru (append). }
var i : integer;
begin
    {$I-} close(fout); {$I+}   { nkdo mohl zapomenout zavt soubor }
    i := IOResult;             { shodme intern pznak }
    {$I-} append(fout);  if IOResult<>0 then rewrite(fout); {$I+}
    if IOResult<>0 then begin
        Imsg('Nespn proveden pkazu AppendOutput.');
        Imsg(' Existuje soubor '''+input_name+'''?');
        Imsg(' Lze jej ppadn vytvoit?');
        Imsg(' Byl ped AppendOutput proveden pkaz AssignOutput?');
        end;
end;


procedure CommandMsg (s:string);
{         ----------
 Vpis zprvy.  Pokud se poda, je vstup pesmrovn do fout.
 Pokud dojde k chyb pi zpisu, je vstup pesmrovn na obrazovku. }
begin
    {$I-} writeln(fout,s); {$I+}
    if IOResult<>0 then begin
        Imsg('Msg - nepodail se zpis do fout.');
        CommandConsole(s);
        end;
end;


procedure CommandMsgnoln (s:string);
{         --------------
 Vpis zprvy - pouze write.  Pokud se poda, je vstup pesmrovn do fout.
 Pokud dojde k chyb pi zpisu, je vstup pesmrovn na obrazovku.
 V tom ppad se po vpisu zprvy oddkuje. }
begin
    {$I-} write(fout,s); {$I+}
    if IOResult<>0 then begin
        Imsg('Msgnoln - nepodail se zpis do fout.');
        CommandConsole(s);
        end;
end;



{ prce s obecnm datovm souborem (generovn dat) ======================}

procedure CommandAssignDataFile (name:string);
{         ---------------------
  Nastav jmno datovho souboru.  Soubor fdata bv otevrn
  bezprostedn ped zpisem a uzavrn bezprostedn po zpisu (append). }
begin
    datafile_name := name;
end;


procedure CommandEraseDataFile;
{         --------------------
  Nehls se chyba, pokud se soubor nepoda smazat
  (pravdpodobn neexistuje). }
var i : integer;
begin
    if datafile_name<>'' then begin
        { Pi voln tto procedury je nutn zajistit, aby soubor byl
          uzaven. K problmm nedochz po vytven datovho souboru,
          protoe se vdy zavr. Pokud se ale soubor pouil jako
          vstupn (ResetInput), pak mohl zstat oteven a ped EraseDataFile
          je nutn jej zavt napklad volnm CloseInput }
        {$I-} assign(fdata,datafile_name); erase(fdata); {$I+}
        i := IOResult;   { shodme intern pznak }
        end;
end;


procedure CommandDataln (s:string);
{         -------------
 Vpis etzce do datovho souboru s ukonenm dku. }
begin
    if datafile_name='' then begin
        Imsg('Dataln - nebylo ureno jmno datovho souboru.');
        exit;
        end;

    assign(fdata,datafile_name);
    {$I-} append(fdata); if IOResult<>0 then rewrite(fdata); {$I+}
    if IOResult<>0 then begin
        Imsg('Dataln - soubor nelze otevt pro zpis:');
        Imsg(' '+datafile_name);
        Imsg(' '+s);
        end
    else begin
        writeln(fdata,s);
        CommandMsg(s);
        close(fdata);  { pokad zaveme }
        end;
end; { CommandDataln }


procedure CommandData (s:string);
{         -----------
 Vpis etzce do datovho souboru bez ukonen dku. }
begin
    if datafile_name='' then begin
        Imsg('Data - nebylo ureno jmno datovho souboru.');
        exit;
        end;

    assign(fdata,datafile_name);
    {$I-} append(fdata); if IOResult<>0 then rewrite(fdata); {$I+}
    if IOResult<>0 then begin
        Imsg('Data - soubor nelze otevt pro zpis:');
        Imsg(' '+datafile_name);
        Imsg(' '+s);
        end
    else begin
        write(fdata,s);
        CommandMsgnoln(s);
        close(fdata);  { pokad zaveme }
        end;
end; { CommandData }



{ prce s log-souborem (ladn, registrace chyb,...) =====================}

procedure CommandAssignLogFile (name:string);
{         --------------------
  Nastav jmno log-souboru.  Jmno log-souboru mus bt uvedeno bez cesty
  (log-soubor se vytv v pracovnm adresi).  Soubor flog bv otevrn
  bezprostedn ped zpisem a uzavrn bezprostedn po zpisu (append). }
begin
    log_name := name;
end;


procedure CommandEraseLogFile;
{         -------------------
  Nehls se chyba, pokud se soubor nepoda smazat
  (pravdpodobn neexistuje). }
var i : integer;
begin
    {$I-} assign(flog,log_name); erase(flog); {$I+}
    i := IOResult;    { shodme intern pznak }
end;


procedure CommandLog (s:string);
{         ----------
 Vpis zprvy do log-souboru. }
begin
    assign(flog,log_name);
    {$I-} append(flog); if IOResult<>0 then rewrite(flog); {$I+}
    if IOResult<>0 then begin
        CommandConsole('Log: Soubor '+log_name+' nelze otevt pro zpis.');
        CommandConsole(s);
        end
    else begin
        writeln(flog,s);
        close(flog);  { pokad zaveme }
        end;
end; { CommandLog }


{ miscelaneous ===========================================================}

procedure Imsg (msg:string);
{         ----
 Tato procedura se vol v ppad oznamovn chyby nebo varovn.
 Vype vizitka interpretu s udnm pozice ve skriptu, pi kter byla
 procedura vyvolna.  Zprva se vypisuje do fout, na obrazovku
 a do log-souboru.  Vdy vol CommandBeep. }
var
    s : string;
    sline : string;
    i : integer;
begin
    str(script_lnum,sline);      { slo dku ve skriptu }
    if script_name='' then
        s := 'INTERPRET: '
    else s := '('+script_name+':'+sline+') ';

    {$I-} writeln(fout,s,msg); {$I+}
    i := IOResult;  { shodme intern pznak }
    CommandConsole(s+msg);
    CommandLog(s+msg);
    CommandBeep;
end;  { Imsg }


procedure CommandBeep;
{         -----------
  Ppne, ale pouze beep_times krt za program. }
var
    d : integer;
    base : integer;
begin
    d := 30;
    base := 440;
    if beep_times>0 then begin
        if odd(beep_times) then begin sound(4*base); delay(d); end
                           else begin sound(3*base); delay(d); end;
        nosound;
        end;
    beep_times := beep_times - 1;
end;


procedure CommandConsole (s:string);
{         --------------
 Vpis na display. }
begin
    Writeln(stdout,s);  { nevypisuje na display pi
                          pesmrovn standardnho vstupu }
end;


procedure CommandEraseFile (s:string);
{         ----------------
  Smae zadan soubor, ppadn vce soubor zadanch maskou. }
var
    f : file;
    i : integer;
    DirInfo: SearchRec;  { pro FindFirst, FindNext }
begin
    FindFirst(s, Archive, DirInfo);
    while DosError=0 do begin
       {$I-} assign(f,DirInfo.Name); erase(f); {$I+}
       i := IOResult;  { shozen internho pznaku }
       FindNext(DirInfo);
       end;
end;


procedure CommandCommand (s:string);
{         --------------
  Spust COMMAND.COM a ped mu zadan etzec. }
begin
    if s<>'' then  begin
        s:='/C '+s;
        SwapVectors;
        Exec(GetEnv('COMSPEC'), s);
        SwapVectors;
        if DosError<>0
            then Imsg('Run - Nelze spustit COMMAND.COM');
        end;
end;


{ prce s uvedenm skriptem ==============================================}

procedure CommandScript (name:string);
{         -------------
  Oteve nov skript "name".  Pokud se neotevr hlavn skript,
  ukld se jmno pedchozho skriptu do zsobnku a soubor fscript
  se uzavr. }
var
    sptr : tScriptStatusPtr;
    i : integer;
    error : boolean;
begin
    { otestujeme ppustnost nzvu }
    trim(name);          { oeeme mezery }
    error := false;      { optimistick inicializace }

    if (pos('\',name)>0) or (pos(':',name)>0) then begin
        Imsg('Script - jmno souboru se zadv bez cesty (viz ScriptPath):');
        Imsg('        '''+name+'''');
        Imsg('        Tento pkaz se ignoruje.');
        error := true;
        end
    else begin
        { Otestujeme, zda skript nen voln rekurzivn.  Pi prvnm voln
          je hodnota promnn main_script_name nastavena na ''. }
        error := (name=main_script_name);
        sptr := script_stack;
        while not error and (sptr<>nil) do begin
            error := sptr^.script_name=name;
            sptr := sptr^.next;
            end;
        if error then begin
            Imsg('Script - rekurzivn voln skriptu '''+name+'''.');
            Imsg('        Pkaz se ignoruje.');
            end;
        end;

    if not error then begin
        { bylo zadno ppustn jmno skriptu }
        if main_script_name='' then begin
            { Jde o prvn voln, kter otevr hlavn skript.
              dn skript dosud nebyl oteven. }
            main_script_name := name;
            end
        else begin  { Njak skript ji byl oteven. }
            close(fscript);  { zaveme rozpracovan skript }
            new(sptr); { ulome nvratovou adresu rozpracovanho skriptu }
            sptr^.script_name := script_name;
            sptr^.script_lnum := script_lnum;
            sptr^.next := script_stack;
            script_stack := sptr;
            end;

        script_name := name; { jmno novho skriptu }
        script_lnum := 0;    { u novho skriptu zanme vdy od zatku }
        if not OpenScript then begin  { otevi nov skript }
            Imsg('Script - skript '''+script_name+''' se nepodailo otevt:');
            if script_name<>main_script_name then
                Imsg(' ScriptPath = '''+script_path+'''');
            Imsg('        Existuje takov soubor?');
            end;
        end; { if error else }
end; { CommandScript }


procedure CommandScriptPath (s:string);
{         -----------------
  Nastav cestu ke skriptm.  Pi prci s hlavnm skriptem se tato cesta
  ignoruje.  Cesta se neukld na zsobnk => pkaz lze pout jen
  v hlavnm skriptu a plat implicitn pro vechny ostatn skripty.
  Pokud cesta nekon zptnm lomtkem, je doplnno v ppad, e nen
  zadna przdn cesta (= vechny skripty se hledaj v pracovnm adresi,
  ve kterm se nachz tak hlavn skript). }
begin
    trim(s);
    if (length(s)>0) and (s[length(s)]<>'\') then s:=s+'\';
    if script_name<>main_script_name then begin
        Imsg('ScriptPath - lze pout pouze v hlavnm skriptu.');
        Imsg('            Zde se jeho vskyt ignoruje.')
        end
    else  script_path := s;  { nov cesta spn nastavena }
end;


procedure CommandReturn;
{         -------------
  Provede nvrat k pedchozmu skriptu. }
var
    i : integer;
    sptr : tScriptStatusPtr;
begin
    { Pokud existuje odloen pedchoz skript, uzavi souasn skript,
      otevi pedchoz a nastav se na msto, odkud se m pokraovat }
    if script_stack<>nil then begin
        close(fscript);                           { uzavi souasn skript }
        script_name := script_stack^.script_name; { parametry pvodnho    }
        script_lnum := script_stack^.script_lnum;
        sptr := script_stack;               { odstra poloku ze zsobnku }
        script_stack := script_stack^.next;
        dispose(sptr);

        { otevi pvodn skript a pesko ji zpracovan dky }
        if not OpenScript then begin
            Imsg('Return - pvodn skript '''+script_name+
                  '''se nepodailo znovu otevt.');
            end
        else    { podailo se otevt, najdi sprvnou pozici (dek) }
            for i:=1 to script_lnum do readln(fscript);
        end { if neprzdn zsobnk then }
    else
        CommandQuit; { explicitn (nebo implicitn) return v hlavnm skriptu }
end;  { CommandReturn }


procedure CommandQuit;
{         -----------
  Ukon interpretaci vech skript. }
var
    sptr : tScriptStatusPtr;
    i : integer;
begin
    { zrume zsobnk skript }
    while script_stack<>nil do begin
        sptr := script_stack;
        script_stack := script_stack^.next;
        dispose(sptr);
        end;

    { pokud byl njak skript oteven, tak jej zaveme }
    {$I-} close(fscript); {$I+}
    i := IOResult;  { shodme intern pznak }

    quit_interpret := true;   { a se vichni dozv tu hroznou novinu :-) }
end;


{ konstrukce =============================================================}

procedure CommandFor (ch:char; i,j:integer; comstr:string);
{         ----------
  V rozsahu mez i, j provede pkaz(y) comstr.
  Odpovd pascalovskmu FOR...TO... Ped kadm provedenm pkazu
  z comstr jsou v nm vechny vskyty znaku ch nahrazeny (textov)
  aktuln hodnotou indexu. }
var
    index : integer;        { promnn cyklu }
    sindex : string;        { textov podoba hodnoty promnn cyklu }
    n : integer;            { aux }
    s : string;
    cn : integer;
begin
    for index:=i to j do begin
        str(index,sindex);      { textov podoba hodnoty indexu }
        s := '';                { init: commstr-->s pi nhrad ch }
        for n:=1 to length(comstr) do
            if comstr[n]=ch then s:=s+sindex      { nahrazen }
                            else s:=s+comstr[n];  { pouh okoprovn znaku }
        command(s);  { prove pkaz s nahrazenmi znaky }
        end;
end; { CommandFor }


procedure CommandForDown (ch:char; i,j:integer; comstr:string);
{         ----------
  V rozsahu mez i, j provede pkaz(y) comstr.
  Odpovd pascalovskmu FOR...DOWNTO... Ped kadm provedenm pkazu
  z comstr jsou v nm vechny vskyty znaku ch nahrazeny (textov)
  aktuln hodnotou indexu. }
var
    index : integer;        { promnn cyklu }
    sindex : string;        { textov podoba hodnoty promnn cyklu }
    n : integer;            { aux }
    s : string;
    cn : integer;
begin
    for index:=i downto j do begin
        str(index,sindex);      { textov podoba hodnoty indexu }
        s := '';                { init: commstr-->s pi nhrad ch }
        for n:=1 to length(comstr) do
            if comstr[n]=ch then s:=s+sindex      { nahrazen }
                            else s:=s+comstr[n];  { pouh okoprovn znaku }
        command(s);  { prove pkaz s nahrazenmi znaky }
        end;
end; { CommandForDown }


procedure CommandForEnum (ch:char; var enum:string; comstr:string);
{         --------------
  Provede length(enum) cykl, kdy ped kadm provedenm pkazu
  z comstr jsou v nm vechny vskyty znaku ch nahrazeny znakem enum[index]. }
var
    index : integer;        { promnn cyklu }
    n : integer;            { aux }
    s : string;
    cn : integer;
begin
    for index:=1 to length(enum) do begin
        s := '';                { init: commstr-->s pi nhrad ch }
        for n:=1 to length(comstr) do
            if comstr[n]=ch then s:=s+enum[index] { nahrazen }
                            else s:=s+comstr[n];  { pouh okoprovn znaku }
        command(s);  { prove pkaz s nahrazenmi znaky }
        end;
end; { CommandForEnum }


{ natn parametr pkaz =============================================}

function GetError : boolean;
{        --------
  Test na chybu pi Get?val. }
begin
   GetError := GetErrorFlag<>' ';
   GetErrorFlag := ' ';
end;


procedure GetSval (var getstr:string; var sval:string);
{         -------
  Zsk parametr typu string a odstran jej z getstr. Ped natnm
  testuje GetErrorFlag a nepracuje, pokud nebyla pedchoz funkce oetena
  pomoc GetError.  Pi chyb se GetErrorFlag nastavuje na 'S'. }
var
    p1, p2 : integer;
    konec : boolean;
begin
    if GetErrorFlag=' ' then begin
        trim(getstr);              { odstranit mezery }
        if (length(getstr)=0) or (getstr[1]<>'''') then begin
            Imsg('GETSVAL - oekv se etzec  '+getstr);
            GetErrorFlag := 'S';
            end
        else begin
            p1 := 2; { prvn znak etzce }
            p2 := 2; { init }
            konec := false;
            while not konec do begin
                while (p2<=length(getstr)) and (getstr[p2]<>'''') do p2:=p2+1;
                if p2>length(getstr) then begin
                    { nenael se ukonujc apostrof }
                    Imsg('GETSVAL - chybn ukonen etzec  '+getstr);
                    GetErrorFlag := 'S';
                    konec := true;   { konme vyhledvn druh hranice }
                    end
                else if (p2<length(getstr)) and (getstr[p2+1]='''') then begin
                    { zdvojen apostrof se mus zjednoduit }
                    delete(getstr,p2,1);
                    p2 := p2+1;         { budeme pokraovat ve vyhledvn }
                    end
                else if p2<=length(getstr) then konec := true;
                                        { tento apostrof ukonuje etzec }
                end; { while not konec }
            sval := copy(getstr,p1,p2-p1);      { hledan hodnota parametru }
            delete(getstr,1,p2);                { odstranit naten parametr }
            end;
        end
    else Imsg('GETSVAL - vskyt neoeten chyby ('+GetErrorFlag+')');
end; { GetSval }


procedure GetIval (var getstr:string; var ival:integer);
{         -------
  Zsk parametr typu integer a odstran jej z getstr.  Ped natnm
  testuje GetErrorFlag a nepracuje, pokud nebyla pedchoz funkce oetena
  pomoc GetError.  Pi chyb se GetErrorFlag nastavuje na 'I'. }

var
    p, code : integer;
    s : string;
begin
    if GetErrorFlag=' ' then begin
        trim(getstr);        { odstranit mezery }
        if length(getstr)=0 then begin
            Imsg('GETIVAL - oekv se parametr typu integer.');
            GetErrorFlag := 'I';
            end
        else begin
            p := pos(' ',getstr);
            if p=0 then p:=length(getstr)+1;        { za konec sla }
            s := copy(getstr,1,p-1);      { textov podoba parametru }
            val(s,ival,code);             { ival = integer podoba }
            if code<>0 then begin
                Imsg('GETIVAL - oekv se slo typu integer  '+s);
                GetErrorFlag := 'I';
                end;
            delete(getstr,1,p);           { odstranit zpracovan parametr }
            end
        end
    else Imsg('GETIVAL - vskyt neoeten chyby ('+GetErrorFlag+')');
end; { GetIval }


procedure GetCval (var getstr:string; var ch:char);
{         -------
  Zsk parametr typu char (nen omezen apostrofy) a odstran jej z getstr.
  Ped natnm testuje GetErrorFlag a nepracuje, pokud nebyla
  pedchoz funkce oetena pomoc GetError.  Pi chyb se GetErrorFlag
  nastavuje na 'C'. }
begin
    if GetErrorFlag=' ' then begin
        trim(getstr);        { odstranit mezery }
        if length(getstr)=0 then begin
            Imsg('GETCVAL - oekv se parametr typu znak.');
            GetErrorFlag := 'C';
            end
        else begin
            ch := getstr[1];
            delete(getstr,1,1);           { odstranit zpracovan parametr }
            end
        end
    else Imsg('GETCVAL - vskyt neoeten chyby ('+GetErrorFlag+')');
end; { GetCval }


procedure GetRval (var getstr:string; var rval:real);
{         -------
  Zsk parametr typu real a odstran jej z getstr.  Ped natnm
  testuje GetErrorFlag a nepracuje, pokud nebyla pedchoz funkce oetena
  pomoc GetError.  Pi chyb se GetErrorFlag nastavuje na 'R'. }

var
    p, code : integer;
    s : string;
begin
    if GetErrorFlag=' ' then begin
        trim(getstr);        { odstranit mezery }
        if length(getstr)=0 then begin
            Imsg('GETRVAL - oekv se parametr typu real.');
            GetErrorFlag := 'R';
            end
        else begin
            p := pos(' ',getstr);
            if p=0 then p:=length(getstr)+1;        { za konec sla }
            s := copy(getstr,1,p-1);      { textov podoba parametru }
            val(s,rval,code);             { rval = real podoba }
            if code<>0 then begin
                Imsg('GETRVAL - oekv se slo typu real  '+s);
                GetErrorFlag := 'R';
                end;
            delete(getstr,1,p);           { odstranit zpracovan parametr }
            end
        end
    else Imsg('GETRVAL - vskyt neoeten chyby ('+GetErrorFlag+')');
end; { GetRval }



{ pomocn procedury a funkce =============================================}

procedure InitGlobVar;
{         -----------  Inicializace globlnch promnnch }
begin
    input_name := '';      { fin; '' znamen z klvesnice }
    output_name := '';     { fout; '' znamen na display  }

    script_path := '';     { cesta ke vem skriptm }
    script_name := '';     { pln jmno souboru se skriptem   }
    script_lnum := 0;      { slo aktulnho dku ze skriptu }
    script_stack := nil;   { inicializace zsobnku nvratovch adres }
    main_script_name := '';  { init - neexistujc jmno skriptu (hlavn
                             skript nesm bt zadvn z klvesnice; tento
                             stav oetuje procedura Interpret)}

    log_name := IMPLICIT_LOG_NAME; { implicitn jmno log-souboru  }

    datafile_name := '';   { nedefinovan jmno datovho souboru }

    beep_times := 10;              { beep ppne maximln tolikrt }

    int_val := 0;          { globln promnn interpretu typu integer }
    str_val := '';         { globln promnn interpretu typu string  }
    bool_val := false;     { globln promnn interpretu typu boolean }
    heap_size := MemAvail; { celkov velikost heap }
    mark_heap := 0;        { implicitn UsedHeapRel = UsedHeapAbs }
    GetErrorFlag := ' ';   { zatm dn chyba pi Get?val }
end;


procedure trim (var s:string);
{         ----
 Odstran vodn mezery, tabultory a koment od COMMENTCH do konce dku.
 Pi hledn zatku komente nereaguje na obsahy etzc.
 Na zvr odstran koncov mezery a tabultory. }
var
    i, n : integer;
    instr : boolean;  { true <=> nachzme se v 'etzci' }
    konec : boolean;
begin
    { odstranit vodn mezery a tabultory }
    while (pos(' ',s)=1) or (pos(#9,s)=1) do  delete(s,1,1);

    n := length(s)+1;  { init - fiktivn pozice zatku komente }
    instr := false;    { init - mimo etzec }
    i := 1;            { budeme testovat prvn pozici }

    konec := i>length(s);
    while not konec do begin
        if s[i]='''' then                     { zatek nebo konec 'str' }
            instr := not instr
        else if not instr and (s[i]=COMMENTCH) then
            n := i;                           { poten pozice komente }
        { ostatn znaky ignorujeme }
        konec := n=i;      { pozice (ppadn fiktivn) zatku komente? }
        i := i+1;
        end;
    s := copy(s,1,n-1);    { kopruj pouze znaky ped komentem }

    { odstranit koncov mezery a tabultory }
    n := length(s);
    while n>0 do begin
        if (s[n]=' ') or (s[n]=#9) then begin
            delete(s,n,1);
            n := n - 1;
            end
        else n:=0;       { ani mezera, ani tabultor => ukonen cyklu }
        end;
end; { trim }


function OpenScript : boolean;
{        ----------
  Oteve skript script_path\script_name s tm, e u main_script_name
  nepidv script_path.  Vrac true, pokud se skript podailo otevt. }
var sname : string;
begin
    OpenScript := true;  { optimistick inicializace }
    sname := script_name;
    if script_name<>main_script_name then sname:=script_path+sname;
    {$I-} assign(fscript,sname); reset(fscript); {$I+}
    if IOResult<>0 then begin
        OpenScript := false;
        CommandQuit;
        end;
end;


{ due a tlo interpretu =================================================}

procedure SeparateCommand (var comstr:string; var comm:tShortString);
{         ---------------
 Oddl z comstr prvn etzec znak ukonen mezerou (pkaz),
 ulo jej do comm a odstran jej z comstr.  Odstran koment
 a nadbyten a vodn mezery, pkaz v comm pevede na velk psmena. }
var i : integer;
begin
    trim(comstr);  { oznout vodn mezery a koment }
    i := pos(' ',comstr)-1;        { dlka nzvu pkazu }
    if i<0 then i:=length(comstr); { mon pkaz bez parametr }
    comm := copy(comstr,1,i);      { jmno pkazu }
    delete(comstr,1,i+1); { v comstr zbudou jen parametry a dal pkazy }
    for i:=1 to length(comm) do comm[i]:=upcase(comm[i]);      { na VELK }
end;


procedure command (var comstr:string);
{         ------- interpretace jednoho pkazu v comstr }
var
    comm : tShortString;      { jmno pkazu zskan z comstr }
    i,j,k,n : integer;        { doasn promnn vyuvan v rmci }
    s : string;               { ...interpretace jednoho pkazu    }
    sshort : tShortString;
    ch : char;
    il : longint;
begin
    while comstr<>'' do begin
        SeparateCommand(comstr,comm); { oddlen pkazu a zbytku }

        { przdn dky (mohl to bt i koment) ---------------------------}
        if      comm='' then exit   { przdn dky peskakujeme }

        { prce se vstupem -------------------------------------------------}
        else if comm='ASSIGNINPUT' then begin  { uren fyz. jmna fin:text }
            GetSval(comstr,s);                 { fyzick jmno souboru }
            if not GetError then CommandAssignInput(s);
            end
        else if comm='RESETINPUT' then CommandResetInput { oteven fin:text }
        else if comm='CLOSEINPUT' then CommandCloseInput { uzaven fin:text }

        { prce s vstupem -------------------------------------------------}
        else if comm='ASSIGNOUTPUT' then begin  { uren jmna fout:text }
            GetSval(comstr,s);                  { fyzick jmno souboru }
            if not GetError then CommandAssignOutput(s);
            end
        else if comm='REWRITEOUTPUT' then CommandRewriteOutput { fout:text }
        else if comm='APPENDOUTPUT' then CommandAppendOutput { append fout }
        else if comm='MSG' then begin                        { zprva      }
            CommandMsg(comstr);
            comstr := '';  { cel zbytek dku zpracovn }
            end
        else if comm='MSGNOLN' then begin        { zprva bez konce dku  }
            GetSval(comstr,s);
            if not GetError then CommandMsgnoln(s);
            end
        else if comm='NEWLINE' then CommandMsg('')  { nov dek na vstup }
        else if comm='WRITESCRIPTNAME' then begin   { vypi zadan text... }
            GetSval(comstr,s);                      { ... a jmno skriptu  }
            if not GetError then CommandMsg(s+script_name);
            end

        { prce s log-souborem ---------------------------------------------}
        else if comm='ASSIGNLOGFILE' then begin  { jmno log-souboru }
            GetSval(comstr,s);               { fyzick jmno souboru }
            if not GetError then CommandAssignLogFile(s);
            end
        else if comm='ERASELOGFILE' then 
	    CommandEraseLogFile                      { smazat log-soubor }
        else if comm='LOG' then begin                      { do log-file }
            CommandLog(comstr);
            comstr := '';  { cel zbytek dku zpracovn }
            end

        { prce s datovm souborem -----------------------------------------}
        else if comm='ASSIGNDATAFILE' then begin  { jmno souboru s daty    }
            GetSval(comstr,s);                    {  fyzick jmno souboru  }
            if not GetError then CommandAssignDataFile(s);
            end
        else if comm='ERASEDATAFILE' then 
	    CommandEraseDataFile                  { smazat datov soubor    }
        else if comm='DATALN' then begin          { s koncem dku          }
            GetSval(comstr,s);
            if not GetError then CommandDataln(s);
            end
        else if comm='DATA' then begin            { bez konce dku         }
            GetSval(comstr,s);
            if not GetError then CommandData(s);
            end
        else if comm='DATAEOL' then begin         { data do konce dku     }
            CommandDataln(comstr);
            comstr := '';  { cel zbytek dku zpracovn }
            end

        { prce s terminlem -----------------------------------------------}
        else if comm='CON' then begin             { na display  }
            CommandConsole(comstr);
            comstr := '';  { cel zbytek dku zpracovn }
            end
        else if comm='BEEPTIMES' then begin { nastav maximln poet ppnut }
            GetIval(comstr,beep_times);
            if not GetError then
                if beep_times<0 then beep_times:=0; { kvli comm='BEEP' }
            end
        else if comm='BEEP' then begin   { ppne vdy, bez ohledu beep_times }
            i := beep_times;
            beep_times := 2;            { 1/2 vka ppnut (viz CommandBeep }
            CommandBeep;
            beep_times := i;
            end

        { vstup/vstup vnitn hodnoty -------------------------------------}
        { Nsledujc pkazy nastavuj hodnoty implicitn urench
          globlnch promnnch. }
        else if comm='SETBOOL' then begin      { nastav boolean; 0=false }
            GetIval(comstr,i);
            if GetError then Imsg('SetBool - oekv se slo.')
                        else bool_val:=i<>0;
            end
        else if comm='SETINT' then begin
            GetIval(comstr,int_val);  { nastav integer }
            if GetError then Imsg('SetInt - oekv se slo.');
            end
        else if comm='SETSTR' then begin
            GetSval(comstr,str_val); { nastav string  }
            if GetError then Imsg('SetStr - oekv se etzec.');
            end

        { Nsledujc pkazy vypisuj hodnoty implicitn urench globlnch
          promnnch.  Po vpisu hodnoty je vypsna mezera a nen proveden
          pechod na nov dek (v ppad poteby se pouv explicitn
          NEWLINE). }
        else if comm='WRITEBOOL' then begin    { vypi bool_val }
            if bool_val then s:='true'  else s:='false';
            CommandMsgnoln(s+' ');
            end
        else if comm='WRITEINT' then begin     { vypi integer }
            str(int_val:5,s);
            CommandMsgnoln(s+' ');
            end
        else if comm='WRITESTR' then           { vypi string }
            CommandMsgnoln(str_val+' ')

        { konstrukce -------------------------------------------------------}
        else if comm='IF' then begin      { if bool_val then command-string }
            if bool_val then command(comstr);
            end
        else if comm='IFNOT' then begin      { if not bool_val then commstr }
            if not bool_val then command(comstr);
            end
        else if (comm='FOR') or (comm='FORDOWN')
                or (comm='FORENUM') then begin
            {  1. "For CH i1 i2 command_string", kde CH je libovoln vhodn
                  znak (bez apostrof).  Vechny vskyty znaku CH v comstr
                  budou nahrazeny textovou reprezentac hodnoty promnn cyklu.
                  Smanticky odpovd pascalovskmu potanmu cyklu
                  "for i1 to i2 do".

               2. "ForDown CH i1 i2 command_string" - parametry jako
                  v pedchozm ppad.  Smanticky odpovd pascalovskmu
                  potanmu cyklu "for i1 downto i2 do".

               3. "ForEnum CH 'abcd' command_string", kde CH je libovoln
                  vhodn znak (bez apostrof).  Vechny vskyty znaku CH
                  v comstr budou postupn nahrazeny znaky 'abcd'.
            }
            GetCval(comstr,ch);             { zjistme nahrazovan znak }
            if GetError then Imsg(' ForXXX - oekval se nahrazovan znak.')
            else if (ch=' ') or (ch=#9) then begin
                Imsg(' ForXXX - znak '' '' m vznam oddlovae.');
                Imsg('          Implicitn nhrada ''#''');
                ch := '#';
                end
            else if ch=COMMENTCH then begin
                Imsg(' ForXXX - znak '''+COMMENTCH+''' uvozuje poznmku.');
                Imsg('          Implicitn nhrada ''#''');
                ch := '#';
                end
            else if ch='''' then begin
                Imsg(' ForXXX - znak <apostrof> ohraniuje etzec.');
                Imsg('          Implicitn nhrada ''#''');
                ch := '#';
                end
            else if comm='FOR' then begin     { ==== potan cyklus }
                GetIval(comstr,i);            { nateme hranice cyklu }
                if not GetError then GetIval(comstr,j);
                if not GetError then CommandFor(ch,i,j,comstr);
                end
            else if comm='FORDOWN' then begin { ==== potan cyklus (downto)}
                GetIval(comstr,i);            { nateme hranice cyklu }
                if not GetError then GetIval(comstr,j);
                if not GetError then CommandForDown(ch,i,j,comstr);
                end
            else if comm='FORENUM' then begin  { ==== cyklus pes vet }
                GetSval(comstr,s);             { nateme vet }
                if not GetError then CommandForEnum(ch,s,comstr);
                end;
            comstr := '';  { ve za for bylo zpracovno}
            end

        { sledovn stavu Heap ---------------------------------------------}
        { Poznmka: Interpret rovnا vyuv Heap -- nsledujc pkazy
          pouvat s ohledem na to, e si Interpret pidluje pam؜ vdy
          pi otvrn novho skriptu (pkaz Script) a uvoluje ji opt
          po uzaven skriptu (implicitn nebo explicitn Return). }
        else if comm='HEAPMARK' then begin    { nastaven relativn hranice }
            mark_heap := heap_size-MemAvail;
            str(mark_heap:7,sshort);
            s := 'Nastavena relativn hranice na Heap: '+sshort;
            CommandMsg(s);
                { Poznmka: Vpis seln hodnoty mark_heap byl pokusn na
                  chvli zruen, ale ukzalo se, e umouje odhalit chybnou
                  inicializaci nebo jinou chybnou prci s dynamickm 
                  pidlovnm pamti v aktulnm nebo pedchozch pkladech.
                }
            end
        




        else if comm='HEAPUSEDREL' then begin   { pouit prostor relativn }
            str(heap_size-MemAvail-mark_heap:7,sshort);
            s := 'Pouit prostor na Heap (relativn): '+sshort;
            CommandMsg(s);
            end
        else if comm='HEAPUSEDABS' then begin   { pouit prostor absolutn }
            str(heap_size-MemAvail:7,sshort);
            s := 'Pouit prostor na Heap (absolutn): '+sshort;
            CommandMsg(s);
            end
        else if comm='HEAPAVAIL' then begin    { voln prostor }
            str(MemAvail:7,sshort);
            s := 'Momentln voln prostor na Heap   : '+sshort;
            CommandMsg(s);
            end
        else if comm='HEAPSIZE' then begin     { celkov velikost heap }
            str(heap_size:7,sshort);
            s := 'Celkov velikost pamti pro Heap   : '+sshort;
            CommandMsg(s);
            end

        {--------------------- speciality ----------------------------------}
        else if comm='ERASEFILE' then begin    { smazat soubor(y) }
            GetSval(comstr,s);                 { maska }
            if not GetError then CommandEraseFile(s);
            end
        else if comm='SCRIPTPATH' then begin  { nastaven cesty ke skriptm }
            GetSval(comstr,s);
            if not GetError then CommandScriptPath(s);
            end
        else if comm='SCRIPT' then begin          { oteven novho skriptu }
            GetSval(comstr,s);
            if not GetError then CommandScript(s);
            end
        else if comm='RETURN' then           { nvrat k pedchozmu skriptu }
            CommandReturn
        else if comm='QUIT' then      { nsiln ukonen interpretace veho }
            CommandQuit
        else if comm='COMMAND' then begin  { spus command.com s parametry }
            GetSval(comstr,s);
            if not GetError then CommandCommand(s);
            end

        {------- speciln pkaz pro interpretaci nkterho z pklad ------}
else if specialP201(comm,comstr) then { OK => nic }
else if specialP202(comm,comstr) then { OK => nic }
else if specialP203(comm,comstr) then { OK => nic }
else if specialP204(comm,comstr) then { OK => nic }
        else begin
            Imsg('Neoekvan pkaz.');
            Imsg(' Pkaz      : '''+comm+'''');
            Imsg(' Zbytek dku: '''+comstr+'''');
            Imsg(' (oba ve uveden daje jsou uzaveny v apostrofech)');
            end;
        if not solved then begin
            CommandMsg(' Procedura/funkce nebyla implementovna. ');
            CommandReturn;     { ukonme }
            solved := true;    { optimistick pedpoklad - p een bude }
            end;
        end; { while comstr<>'' }
end; {command}


procedure Interpret (scr_name:tShortString);
{         ---------
  Interpretace skriptu scr_name. }
var
    i : integer;
    s : string;
    konec : boolean;
begin
    quit_interpret := false;      { init }
    if scr_name='' then begin     { jmno hlavnho skriptu }
        Imsg('Hlavn skript mus bt fyzick soubor.');
        Imsg(' Pedasn ukonen interpretu.');
        exit;
        end;

    CommandScript(scr_name);       { hlavnm skriptem zaneme }

    while not quit_interpret do begin
        konec := eof(fscript);
        while not konec do    { do konce kadho skriptu }
            begin
            readln(fscript,s);
            script_lnum := script_lnum+1;
            command(s);       { interpretuj dek skriptu }
            { mohlo dojt k zaven fscript}
            {$I-} konec := eof(fscript); {$I+}
            if IOResult<>0 then  { nen oteven dn skript, konec }
                konec := true;
            end;

        if not quit_interpret then
            CommandReturn;    { implicitn nvrat do pedchozho skriptu }
        end;              { ...nebo nic pro hlavn skript }

    { zaveme vechno, co jde (soubory :-) }
    {$I-} Close(fscript); Close(fout); Close(fin); {$I+}
    i := IOResult;  { shodme intern pznak }
end;  { Interpret }



begin  { tlo celho programu }
    InitGlobVar;      { inicializace globlnch promnnch  }
    assign(stdout,'');
    rewrite(stdout);
    solved := true;
    { Pokud je vyhodnocovn pkaz, kter vol proceduru nebo funkci
      eenho pkladu (nkter pkazy interpret specilnch pkaz),
      pedpokldme, e byl een.  Pokud ne, vrt se po proveden
      specilnho pkazu hodnota solved=false.  Na konci procedury command
      je tato situace oetena a promnn solved je opt nastavena na true. }
    if ParamCount<1 then
        Interpret('intrpret.scr')   { implicitn jmno hlavnho skriptu }
    else
        Interpret(ParamStr(1));     { zadan jmno skriptu }
    close(stdout);
end.
