{ Zdrojov soubor /courses/ADS/private/sbirka/intrpret.skl
modifikovn skriptem novyukol.pl }
{ intrpret.pas: Hlavn modul interpretu pedpis pro testovn
                poadovanho chovn implementace een kolu.

Od z 1997 soust systmu SOVA. Do uvedenho data soust systmu OSYS.
Copyright (C) 1994-1998, Petr Pikryl <prikryl@dcse.fee.vutbr.cz>


Historie:
---------
   1.4.1998 - zavedena procedura CommandCloseInput a odpovdajc
              pkaz interpretu
  18.3.1998 - neznm pkaz se nyn vypisuje v apostrofech; obdobn se
              vypisuje i comstr (zbytek dku)
   5.3.1998 - zaveden pkaz DataEol
   2.2.1998 - opt zaveden vpis hodnoty v HeapMark -- viz poznmka na mst.
   2.1.1998 - v pkazu HeapMark se nyn nevypisuje hodnota, ke
              kter se budou vztahovat relativn daje o spoteb Heap
   1.1.1998 - odstrann pkaz interpretu `Difficulty' a odpovdajc
              procedura CommandDifficulty.
            - implicitn jmno hlavnho skriptu zmnno ze `script'
              na intrpret.scr
            - prava identifikace dku pro vkldn rozen
              interpretu
  1.12.1997 - upraveno generovn intrpret.pas pi zveejovn
              novho kolu. Kostra (skeleton) interpretu uloena
              do souboru intrpret.skl. Generovn intrpret.pas
              se provd perl-skriptem, kter pmo do skeletonu
              vkld potebn doplky souvisejc se zadanmi
              pklady kolu => redukce potu soubor, zobecnn
              na libovoln poet pklad kolu.
 listopad 1994 - verze 1.1 (soubor intrpret.pas)
}

{$M 64000,50000,200000} {= stack size, heap min, heap max}

uses DOS, Crt, UkolX;   { modul UkolX je hlavnm modulem eenho kolu}

{--------------------------------------------------------------------}
{ vnitn konstanty a typy interpretu }
const
    COMMENTCH = '%';     { comment to the end of line }
    IMPLICIT_LOG_NAME = 'logfile';    { implicitn jmno log-souboru }
    SSTRING_LEN = 30;    { dlka krtkho etzce (mus bt alespo 13
                           kvli ukldn jmna souboru) }
type
    tShortString = string[SSTRING_LEN];  { krtk etzec }
    tScriptStatusPtr = ^tScriptStatus;
    tScriptStatus = record   { zznam o odloenm skriptu (nvratov adresa) }
        script_name : tShortString;  { jmno souboru se skriptem   }
        script_lnum : integer;       { poet zpracovanch dk    }
        next : tScriptStatusPtr;     { ukazatel na dal zznam    }
        end;

{******* Globln promnn a standardn funkce interpretu pklad *******}
var
    main_script_name : string; { jmno hlavnho skriptu }
    fscript     : text;      { textov soubor s interpretovanm skriptem }
    script_path : string;    { cesta ke vem skriptm (krom hlavnho) }
    script_name : string;    { jmno souboru se skriptem          }
    script_lnum : integer;   { slo aktulnho dku ze skriptu  }
    script_stack : tScriptStatusPtr; { zsobnk nvratovch adres }
    log_name    : string;      { jmno log-souboru      }
    flog        : text;        { log-soubor             }
    datafile_name : string;    { jmno datovho souboru }
    fdata       : text;        { datov soubor          }
    beep_times  : integer;     { maximln poet ppnut za program    }
    quit_interpret : boolean;  { pznak poadavku ukonen interpretu }

    { Nsledujc globln promnn interptretu jsou uren pro pedvn
      hodnot pslunho typu mezi rznmi pkazy.  Nepouvaj se jako
      pomocn promnn. }
    int_val     : integer; { globln promnn interpretu typu integer }
    str_val     : string;  { globln promnn interpretu typu string  }
    bool_val    : boolean; { globln promnn interpretu typu boolean }
    mark_heap   : longint; { relativn hranice pouvanho prostoru v Heap }
    heap_size   : longint; { celkov velikost Heap }

    input_name  : string;  { jmno vstupnho textovho souboru fin  }
    output_name : string;  { jmno vstupnho text. souboru fout    }
  { Vstupn textov soubor fin:text a vstupn textov soubor
    fout:text jsou deklarovny na zatku programu jako globln,
    viditeln pro vechy een pklady.  Jmna tchto soubor lze zadvat
    s plnou cestou. }
    stdout : text;         { kvli Crt, aby fungovalo pesmrovn }

    GetErrorFlag : char;   { nastavuje se pi chyb v procedurch Get?val:
                               ' ' ... bez chyby
                               '?' ... chyba pi Get?val (velk psmeno) }

{-----------------------------------------------------------------------}

{ prce se vstupem (soubor fin) }
procedure CommandAssignInput (name:string);                  forward;
procedure CommandResetInput;                                 forward;
procedure CommandCloseInput;                                 forward;

{ prce s vstupem (soubor fout) }
procedure CommandAssignOutput (name:string);                 forward;
procedure CommandRewriteOutput;                              forward;
procedure CommandAppendOutput;                               forward;
procedure CommandMsg (s:string);                             forward;
procedure CommandMsgnoln (s:string);                         forward;

{ prce s obecnm datovm souborem (generovn vstupnch textovch dat) }
procedure CommandAssignDataFile(name:string);                forward;
procedure CommandEraseDataFile;                              forward;
procedure CommandDataln (s:string);                          forward;
procedure CommandData (s:string);                            forward;

{ prce s log-souborem (ladn, registrace chyb,...) }
procedure CommandAssignLogFile (name:string);                forward;
procedure CommandEraseLogFile;                               forward;
procedure CommandLog (s:string);                             forward;

{ miscelaneous }
procedure Imsg (msg:string);                                 forward;
procedure CommandBeep;                                       forward;
procedure CommandConsole (s:string);                         forward;
procedure CommandEraseFile (s:string);                       forward;
procedure CommandCommand (s:string);                         forward;

{ prce s uvedenm skriptem }
procedure CommandScript (name:string);                       forward;
procedure CommandScriptPath (s:string);                      forward;
procedure CommandReturn;                                     forward;
procedure CommandQuit;                                       forward;

{ konstrukce }
procedure CommandFor (ch:char; i,j:integer; comstr:string);  forward;
procedure CommandForDown (ch:char; i,j:integer; comstr:string);  forward;
procedure CommandForEnum (ch:char; var enum:string; comstr:string);  forward;

{ natn parametr pkaz }
function  GetError : boolean;                                forward;
procedure GetSval (var getstr:string; var sval:string);      forward;
procedure GetIval (var getstr:string; var ival:integer);     forward;
procedure GetCval (var getstr:string; var ch:char);          forward;
procedure GetRval (var getstr:string; var rval:real);        forward;

{ pomocn procedury a funkce }
procedure InitGlobVar;                                       forward;
procedure trim (var s:string);                               forward;
function  OpenScript : boolean;                              forward;

{ due a tlo interpretu }
procedure SeparateCommand (var comstr:string; var comm:tShortString); forward;
procedure command (var comstr:string);                       forward;
procedure Interpret (scr_name:tShortString);                 forward;



{ *** Rozen interpretu pro konkrtn pklady ***}
{ p301.iex: rozen funkce interpretu o speciln pkazy k pkladu }

const P301MAXDEPTH = 15; { pedpokldan max. hloubka stromu (pro tisk) }
type  P301Str = string[60];   { pomocn typ pro P301PrintTree }
var P301Root : tPNodePtr;     { koen stromu pro testovn    }


procedure P301PrintTree2 (RootPtr:tPNodePtr; level:integer;
{         --------------} sufix:P301Str;
                          fromdir:char);  { 'L'eft, 'R'ight, 'X' = Root }
{ Tisk obsahu stromu s grafickm znzornnm jeho struktury.  Jde o pklad
  mlo komentovanho zdrojovho textu - pouvejte mnohem vce koment.
  Semigrafick znaky jsou okomentovan pro ppad chybnho zobrazen
  pi tisku zdrojovho textu. }
var
    ch : char;
    i : integer;
begin
    if RootPtr<>nil then begin
        while (length(sufix)>0) and (sufix[length(sufix)]=' ') do
            delete(sufix,length(sufix),1); { zruit pravostrann mezery }

        if fromdir='R' then ch:='' else ch:=' ';  { svisl rka }
        P301PrintTree2(RootPtr^.LPtr,level+1,ch+' '+sufix,'L');

        write(fout,RootPtr^.Cont:4,' ');
        for i:=1 to (P301MAXDEPTH-level)*2 do write(fout,' ');
        write(fout,'');  { tvereek a vodorovn rka}

        if fromdir='L' then writeln(fout,' ',sufix)      { prav horn roh }
        else if fromdir='R' then writeln(fout,' ',sufix) { prav doln roh }
        else writeln(fout,'[root]');

        if fromdir='L' then ch:='' else ch:=' ';         { svisl rka }
        P301PrintTree2(RootPtr^.RPtr,level+1,ch+' '+sufix,'R');
        end;
end; { P301PrintTree }


procedure P301PrintTree (root : tPNodePtr);
{         -------------
    Nadstavba nad P301PrintTree2. }
var i : integer;
begin
    for i:=1 to 15 do write(fout,'');  { vodorovn rka }
    writeln(fout);
    if root=nil then writeln(fout,'(root = nil)')
                 else P301PrintTree2(root,0,'','X');
    for i:=1 to 15 do write(fout,'');
    writeln(fout);                      { vodorovn rka }
end;


function specialP301 (var comm:tShortString; var comstr:string):boolean;
var i : integer;
begin
    specialP301 := true;                { init }
    if comm='PBTINIT' then begin        { inicializace stromu }
        WriteLn(fout, 'Operace PBTInit(Root)');
        PBTInit(P301Root);
        end
    else if comm='PBTPRINTTREE' then begin   { vytiskni strom (pascal DPP) }
        WriteLn(fout, 'Obsah stromu:');
        P301PrintTree(P301Root);
        end
    else if comm='PBTINSERT' then begin      { vlo zadan prvek }
        GetIval(comstr,i);                   { zskej vkldanou hodnotu }
        if not GetError then begin
            WriteLn(fout, 'Operace PBTInsert(Root, ', i:2, ')');
            PBTInsert(P301Root,i);   { vlo do stromu }
            end;
        end
    else if comm='PBTDELETELR' then begin
        GetIval(comstr,i);      { zskej hodnotu }
        if not GetError then begin
            WriteLn(fout, 'Operace PBTDeleteLR(Root, ', i:2, ')');
            PBTDeleteLR(P301Root,i);
            end;
        end
    else if comm='PBTPREORDER' then begin
        WriteLn(fout, 'Bude voln prchod PBTPreOrder(Root) ',
                      'nsledujcm stromem:');
        P301PrintTree(P301Root);
        Write(fout, 'Preorder:');
        PBTPreOrder(P301Root);
        WriteLn(fout);
        end
    else if comm='PBTINORDER' then begin
        WriteLn(fout, 'Bude voln prchod PBTInOrder(Root) ',
                      'nsledujcm stromem:');
        P301PrintTree(P301Root);
        Write(fout, 'Inorder:');
        PBTInOrder(P301Root);
        WriteLn(fout);
        end
    else if comm='PBTPOSTORDER' then begin
        WriteLn(fout, 'Bude voln prchod PBTPostOrder(Root) ',
                      'nsledujcm stromem:');
        P301PrintTree(P301Root);
        Write(fout, 'Postorder:');
        PBTPostOrder(P301Root);
        writeln(fout);
        end
    else if comm='PBTDISPOSETREE' then begin
        WriteLn(fout, 'Operace PBTDisposeTree(Root)');
        PBTDisposeTree(P301Root);
        end
    else specialP301 := false;   { nenalezen vhodn pkaz }
end;

{ p310.iex: Implementace nestandardnch funkc interpretu specilnch
            pkaz k pkladu }

const
    UNDEF = 8888;  { tato konstanta se pouv jen kvli oeten
                     stejnch textovch vstup u vech een. }
var
    A, B, C, D, E : tUNodePtr; { ukazatel pro testovn UDPP }
    AuxNode : tUNode;          { pomocn pro testovn UDPPWrite/Read }



procedure UndefNodes (var UDPP:tUDPP);
{         ----------
  Projde cel prostor a pidl nedefinovan hodnoty podle toho,
  zda je uzel pidlen nebo voln. }
var i : integer;
begin
    for i:=1 to UDPPSize do begin
        with UDPP do begin     { inicializace na nedefinovan hodnoty }
            if Arr[i].Free then begin
                Arr[i].Node.Cont := UNDEF;
                Arr[i].Node.LPtr := UNDEF;
                Arr[i].Node.RPtr := UNDEF;
                end
            else Arr[i].Next := UNDEF;
            end; { with }
        end;
end; { UndefNodes }


procedure PrintNodeGraph (n:integer;   { typ grafickho dku }
{         --------------} UDPP:tUDPP; Ptr:tUNodePtr;
                          IsFirst, IsLast:boolean);
{ Vytiskne kousek grafick reprezentace jednoho uzlu (prvn dkek).
  Pokud je IsFirst, tisknou se ppadn jin znaky na pedn stran
  buky. IsLast -- chpe se jako posledn vykreslovan uzel a proto se
  pidv uzavrac znak, ale neprovd se writeln. }
const w = 6; { ka jednoho grafickho prvku (bez uzavracho znaku) }
var
    s : string[10];   { aux }
    sw : string[w];   { obrzek ped petiskem }
    sn : string[10];  { znakov reprezentace sla (mus se pouze vejt) }
begin
    if (Ptr<1) or (Ptr>UDPPSize) then { nesplniteln poadavek }
        write(fout,'')
    else begin
        case n of
          1:begin                    { znzornme polohu TopPtr }
            if UDPP.TopPtr=UNDEF then        write(fout,'')
            else if UDPP.TopPtr=UDPPNil then write(fout,'')
            else if Ptr=UDPP.TopPtr then     write(fout,'TopPtr')
            else                             write(fout,'      ');
            if IsLast then begin     { uzavrac znak }
                if UDPP.TopPtr=UNDEF then        write(fout,'')
                else if UDPP.TopPtr=UDPPNil then write(fout,'')
                else                             write(fout,' ');
                end;
            end;

          2:begin   { horn hrana obrzku s indexem }
            sw := '';             { obrzek ped petiskem     }
            str(Ptr,sn);                { indexem budeme petiskovat }
            delete(sw,2,length(sn));  insert(sn,sw,2);     { petisk }
            if IsFirst then sw[1]:='';
            write(fout,sw);
            if IsLast then write(fout,'');
            end;   { 2 }

          3:begin   { st obrzku s obsahem uzlu }
            sw := ' ';
            { tisk pslun hodnoty (vdy na 3 msta) }
            if UDPP.Arr[Ptr].Node.Cont=UNDEF then     sn := ''
            else if UDPP.Arr[Ptr].Node.Cont>999 then  sn := 'XXX'
            else str(UDPP.Arr[Ptr].Node.Cont:3,sn);
            sw := sw+sn+' ';
            write(fout,sw);
            if IsLast then write(fout,'');
            end;   { 3 }

          4:begin { nenron st obrzku }
            sw := '';
            if IsFirst then sw[1]:='';
            write(fout,sw);
            if IsLast then write(fout,'');
            end;   { 4 }

          5:begin { st obrzku s ukazateli uzlu }
            sw := '';
            { hodnota levho ukazatele (vdy na 2 msta) }
            if UDPP.Arr[Ptr].Node.LPtr=UNDEF then         sn := ''
            else if UDPP.Arr[Ptr].Node.LPtr=UDPPNil then  sn := ''
            else if UDPP.Arr[Ptr].Node.LPtr>UDPPSize then sn := ' >'
            else if UDPP.Arr[Ptr].Node.LPtr<1 then        sn := ' <'
            else str(UDPP.Arr[Ptr].Node.LPtr:2,sn);
            sw := sw+sn+'';
            { stejnm zpsobem prav }
            if UDPP.Arr[Ptr].Node.RPtr=UNDEF then         sn := ''
            else if UDPP.Arr[Ptr].Node.RPtr=UDPPNil then  sn := ''
            else if UDPP.Arr[Ptr].Node.RPtr>UDPPSize then sn := ' >'
            else if UDPP.Arr[Ptr].Node.RPtr<1 then        sn := ' <'
            else str(UDPP.Arr[Ptr].Node.RPtr:2,sn);
            sw := sw+sn;
            write(fout,sw);                              { tisk    }
            if IsLast then write(fout,'');
            end;   { 5 }

          6:begin { doln hrana obrzku s ukazatelem Next }
            sw := '';
            if IsFirst then sw[1]:='';
            if UDPP.Arr[Ptr].Next=UNDEF then         sn := ''
            else if UDPP.Arr[Ptr].Next=UDPPNil then  sn := ''
            else if UDPP.Arr[Ptr].Next>UDPPSize then sn := ' >'
            else if UDPP.Arr[Ptr].Next<1 then        sn := ' <'
            else str(UDPP.Arr[Ptr].Next,sn);
            delete(sw,w-length(sn)+1,length(sn));
            insert(sn,sw,w-length(sn)+1);                { petisk }
            write(fout,sw);                              { tisk    }
            if IsLast then write(fout,'');
            end;   { 6 }

          7:begin { st obrzku s indikac pidlen poloky }
            if UDPP.Arr[Ptr].Free then write(fout,' FREE ')
                                  else write(fout,'      ');
            if IsLast then write(fout,' ');
            end;   { 7 }

          8:begin   { horn hrana obrzku bez indexu }
            sw := '';
            if IsFirst then sw[1]:='';
            write(fout,sw);
            if IsLast then write(fout,'');
            end;   { 8 }

          9:begin { doln hrana obrzku bez ukazatele Next }
            sw := '';
            if IsFirst then sw[1]:='';
            write(fout,sw);                              { tisk    }
            if IsLast then write(fout,'');
            end;   { 9 }

          else begin
            str(n,s);
            Imsg('PrintNodeGraph: nen definovno pro typ dku '+s);
            exit;
            end
          end; { case }
        end; { if ... else }
end; { PrintNodeGraph }


procedure PrintHeapGraph (UDPP:tUDPP; Ptr:tUNodePtr; Count:integer);
{         --------------
  Vytiskne stav uivatelskho Heap od pozice Ptr v dlce Count poloek.
  Tato procedura je implementan zvisl. }
var
    i,j : integer;
    r : integer;      { index poslednho tisknutho (right) }
begin
    r := Ptr+Count-1;                 { zjistme posledn tisknut prvek }
    if r<1 then r:=1;                 { ppadn korekce poslednho }
    if r>UDPPSize then r:=UDPPSize;
    if Ptr<1 then Ptr:=1;             { ppadn korekce prvnho tisknutho }
    if Ptr>UDPPSize then Ptr:=UDPPSize;

    { vytiskneme vechny dky grafickho znzornn Heap }
    for j:=1 to 7 do begin
        if Ptr=1 then write(fout,':')
        else if j=5 then write(fout,'... ')
        else write(fout,'    ');

        for i:=Ptr to r do PrintNodeGraph(j,UDPP,i,i=Ptr,i=r);

        if r=UDPPSize then
            writeln(fout,':')
        else if j=5 then writeln(fout,' ...')
        else writeln(fout);
        end;
end; { PrintHeapGraph }


procedure PrintListGraph (UDPP:tUDPP; FirstPtr:tUNodePtr; ActPtr:tUNodePtr);
{         --------------
  Vytiskne stav uivatelskho Heap v podob linernho seznamu, tedy
  obdlnky poskldan podle poad v seznamu.  Na prvn poloku ukazuje
  FirstPtr.  Tiskne se od prvn poloky a postupuje se podle ukazatele RPtr.
  Tisk kon v okamiku, kdy se naraz na UDPPNil, UNDEF nebo na odkaz mimo
  rozsah UDPP.  Znzorn polohu aktivnho prvku, na kter ukazuje ukazatel
  Act.  Tato procedura je implementan zvisl. }
var
    ptr : tUNodePtr;  { pomocn }
    i : integer;

    function PointsToNode (Ptr:tUNodePtr) : boolean;
    begin{   ------------ pznak "ukazuje na uzel" }
        PointsToNode := (Ptr<>UDPPNil) and (Ptr<>UNDEF)
                        and (Ptr>=1) and (Ptr<=UDPPSize);
    end;

begin
    if (FirstPtr<>UDPPNIL) and ((FirstPtr<1) or (FirstPtr>UDPPSize)) then
        begin
        writeln(fout,'PrintListGraph: FirstPtr - odkaz mimo rozsah UDPP');
        exit;
        end;

    if FirstPtr=UNDEF then begin
        writeln(fout,'PrintListGraph: FirstPtr - odkaz pes nedefinovan ',
                                      'obsah ukazatele.');
        exit;
        end;

    if (ActPtr<>UDPPNIL) and ((ActPtr<1) or (ActPtr>UDPPSize)) then begin
        writeln(fout,'PrintListGraph: ActPtr - odkaz mimo rozsah UDPP');
        exit;
        end;

    if ActPtr=UNDEF then begin
        writeln(fout,'PrintListGraph: ActPtr - odkaz pes nedefinovan ',
                                      'obsah ukazatele.');
        exit;
        end;

    { vytiskneme rmeek s indexem a obsah uzlu (typ 2-6) }
    for i:=2 to 6 do begin
        ptr := FirstPtr; write(fout,':');
        while PointsToNode(ptr) do begin
            PrintNodeGraph(i,UDPP,ptr,true,true);
            ptr := UDPP.Arr[ptr].Node.Rptr;   { odkaz na nsledujcho }
            end;
        if (ptr<>UDPPNil) then writeln(fout,'???????')
                          else writeln(fout,':');
        end;

    { znzornme aktivitu }
    ptr := FirstPtr; write(fout,':');
    while PointsToNode(ptr) do begin
        if ptr=ActPtr then write(fout,'  Act  ') else write(fout,'       ');
        ptr := UDPP.Arr[ptr].Node.Rptr;   { odkaz na nsledujcho }
        end;
    if (ptr<>UDPPNil) then writeln(fout,'???????')
                      else writeln(fout,':');

end; { PrintListGraph }


procedure PrintNode (var UDPP:tUDPP; Ptr:tUNodePtr);
{         ---------
  Vytiskne obsah uzlu, na kter ukazuje Ptr.
  Tato procedura je implementan zvisl. }
begin
    { oetme ppady odkazu na neexistujc poloky }
    if Ptr=UDPPNil then writeln(fout,'(nil)')
    else if Ptr=UNDEF then writeln(fout,'(nedefinovan hodnota ukazatele)')
    else if (Ptr<1) or (Ptr>UDPPSize) then
        writeln(fout,'(odkaz mimo rozsah prostoru pro pidlovn)')
    else begin  { vytiskneme hodnotu ukazatele a obsah pslun buky }
        write(fout,Ptr,' --> ');
        if UDPP.Arr[Ptr].Free then writeln(fout,'(FREE)')
        else begin  { poloka je pidlena, vytiskneme hodnoty uzlu }
            write(fout,'(Cont = ');
            { obsah uzlu }
            if UDPP.Arr[Ptr].Node.Cont=UNDEF then
                write(fout,', ')
            else write(fout,UDPP.Arr[Ptr].Node.Cont:3,', ');

            { obsah levho ukazatele }
            write(fout,'LPtr = ');
            if UDPP.Arr[Ptr].Node.LPtr=UDPPNil then       write(fout,'nil, ')
            else if UDPP.Arr[Ptr].Node.LPtr=UNDEF then    write(fout,', ')
            else if UDPP.Arr[Ptr].Node.LPtr<1 then        write(fout,' < , ')
            else if UDPP.Arr[Ptr].Node.LPtr>UDPPSize then write(fout,' > , ')
            else write(fout,UDPP.Arr[Ptr].Node.LPtr:3,', ');

            { obsah pravho ukazatele }
            write(fout,'RPtr = ');
            if UDPP.Arr[Ptr].Node.RPtr=UDPPNil then       write(fout,'nil')
            else if UDPP.Arr[Ptr].Node.RPtr=UNDEF then    write(fout,'')
            else if UDPP.Arr[Ptr].Node.RPtr<1 then        write(fout,' < ')
            else if UDPP.Arr[Ptr].Node.RPtr>UDPPSize then write(fout,' > ')
            else write(fout,UDPP.Arr[Ptr].Node.RPtr:3);

            writeln(fout,')');
            end
        end;
end;  { PrintNode }


procedure PrintAuxNode;
{         ------------
  Vytiskne obsah pomocnho uzlu. }
begin
    write(fout,'(Cont = ');
    { obsah uzlu }
    if AuxNode.Cont=UNDEF then
        write(fout,', ')
    else write(fout,AuxNode.Cont:3,', ');

    { obsah levho ukazatele }
    write(fout,'LPtr = ');
    if AuxNode.LPtr=UDPPNil then       write(fout,'nil, ')
    else if AuxNode.LPtr=UNDEF then    write(fout,', ')
    else if AuxNode.LPtr<1 then        write(fout,' < , ')
    else if AuxNode.LPtr>UDPPSize then write(fout,' > , ')
    else write(fout,AuxNode.LPtr:3,', ');

    { obsah pravho ukazatele }
    write(fout,'RPtr = ');
    if AuxNode.RPtr=UDPPNil then       write(fout,'nil')
    else if AuxNode.RPtr=UNDEF then    write(fout,'')
    else if AuxNode.RPtr<1 then        write(fout,' < ')
    else if AuxNode.RPtr>UDPPSize then write(fout,' > ')
    else write(fout,AuxNode.RPtr:3);

    writeln(fout,')');
end; { PrintAuxNode }




procedure NewAndUndef (var UDPP:tUDPP; var Ptr:tUNodePtr);
{         -----------
  Ukazateli Ptr pidl poloku pomoc UDPPNew a nastav pslun
  hodnoty v polokch na nedefinovanou hodnotu. }
begin
    UDPPNew(UDPP,Ptr);
    UndefNodes(UDPP);
end;  { NewAndUndef }


procedure DisposeAndUndef (var UDPP:tUDPP; var Ptr:tUNodePtr);
{         ---------------
  Uvoln poloku volnm UDPPDispose a nastav pslun
  hodnoty v polokch na nedefinovanou hodnotu. }
begin
    UDPPDispose(UDPP,Ptr);
    UndefNodes(UDPP);
end;  { DisposeAndUndef }



function specialP310 (var comm:tShortString; var comstr:string):boolean;
{        ----------------
  Speciln funkce interpretu k danmu pkladu }
var i, j, k : integer;
begin
    specialP310 := true;                 { init }
    errflg := false;     { init - dodud nebyla oetovna chyba }
    if comm='UDPPHEAPSIZE' then begin
        GetIval(comstr,i); { nateme a zkorigujeme pouvanou velikost Heap }
        if i<1 then i:=1 else if i>UDPPMaxSize then i:=UDPPMaxSize;
        UDPPSize := i;             { nastavme velikost prostoru }
        with UDPP do begin     { inicializace na nedefinovan hodnoty }
            TopPtr := UNDEF;
            for i:=1 to UDPPSize do begin
                Arr[i].Node.Cont := UNDEF;
                Arr[i].Node.LPtr := UNDEF;
                Arr[i].Node.RPtr := UNDEF;
                Arr[i].Free := odd(i);
                Arr[i].Next := UNDEF;
                end; { for }
            end; { with }
        { inicializujeme pomocn ukazatele na nedefinovan hodnoty }
        A:=UNDEF;  B:=UNDEF;  C:=UNDEF;  D:=UNDEF;  E:=UNDEF;
        { inicializujeme pomocn uzel na nedefinovan hodnoty }
        AuxNode.Cont := UNDEF;
        AuxNode.LPtr := UNDEF;
        AuxNode.RPtr := UNDEF;
        end { begin }
    else if comm='UPRINTHEAP' then begin
        { tisk sti UDPP prostoru -- 2 parametry: odkud, kolik prvk }
        GetIval(comstr,i);               { odkud }
        GetIval(comstr,j);               { kolik }
        if (i<>-MAXINT) and (j<>-MAXINT) then
            PrintHeapGraph(UDPP,i,j); { pokud byly parametry zadny OK }
        end
    else if comm='UDPPINIT' then UDPPInit(UDPP)
    else if comm='UPRINTNODE:A' then PrintNode(UDPP,A)
    else if comm='UPRINTNODE:B' then PrintNode(UDPP,B)
    else if comm='UPRINTNODE:C' then PrintNode(UDPP,C)
    else if comm='UPRINTNODE:D' then PrintNode(UDPP,D)
    else if comm='UPRINTNODE:E' then PrintNode(UDPP,E)
    else if comm='UDPPNEW:A' then NewAndUndef(UDPP,A)
    else if comm='UDPPNEW:B' then NewAndUndef(UDPP,B)
    else if comm='UDPPNEW:C' then NewAndUndef(UDPP,C)
    else if comm='UDPPNEW:D' then NewAndUndef(UDPP,D)
    else if comm='UDPPNEW:E' then NewAndUndef(UDPP,E)
    else if comm='UDPPDISPOSE:A' then DisposeAndUndef(UDPP,A)
    else if comm='UDPPDISPOSE:B' then DisposeAndUndef(UDPP,B)
    else if comm='UDPPDISPOSE:C' then DisposeAndUndef(UDPP,C)
    else if comm='UDPPDISPOSE:D' then DisposeAndUndef(UDPP,D)
    else if comm='UDPPDISPOSE:E' then DisposeAndUndef(UDPP,E)
    else if comm='UASSIGNAUXNODE' then begin
        GetIval(comstr,i);               { Cont }
        GetIval(comstr,j);               { LPtr }
        GetIval(comstr,k);               { RPtr }
        if (i<>-MAXINT) and (j<>-MAXINT) and (k<>-MAXINT) then begin
            { pokud byly zadny ti seln parametry }
            AuxNode.Cont := i;
            AuxNode.LPtr := j;
            AuxNode.RPtr := k;
            end;
        end
    else if comm='UUNDEFAUXNODE' then begin
        AuxNode.Cont := UNDEF;
        AuxNode.LPtr := UNDEF;
        AuxNode.RPtr := UNDEF;
        end
    else if comm='UPRINTAUXNODE' then PrintAuxNode
    else if comm='UDPPWRITE:A' then UDPPWrite(UDPP,A,AuxNode)
    else if comm='UDPPWRITE:B' then UDPPWrite(UDPP,B,AuxNode)
    else if comm='UDPPWRITE:C' then UDPPWrite(UDPP,C,AuxNode)
    else if comm='UDPPWRITE:D' then UDPPWrite(UDPP,D,AuxNode)
    else if comm='UDPPWRITE:E' then UDPPWrite(UDPP,E,AuxNode)
    else if comm='UDPPREAD:A' then UDPPRead(UDPP,A,AuxNode)
    else if comm='UDPPREAD:B' then UDPPRead(UDPP,B,AuxNode)
    else if comm='UDPPREAD:C' then UDPPRead(UDPP,C,AuxNode)
    else if comm='UDPPREAD:D' then UDPPRead(UDPP,D,AuxNode)
    else if comm='UDPPREAD:E' then UDPPRead(UDPP,E,AuxNode)
    else if comm='UASSIGNNIL:A' then A:=UDPPNil
    else if comm='UASSIGNNIL:B' then B:=UDPPNil
    else if comm='UASSIGNNIL:C' then C:=UDPPNil
    else if comm='UASSIGNNIL:D' then D:=UDPPNil
    else if comm='UASSIGNNIL:E' then E:=UDPPNil
    else if comm='UASSIGNUNDEF:A' then A:=UNDEF
    else if comm='UASSIGNUNDEF:B' then B:=UNDEF
    else if comm='UASSIGNUNDEF:C' then C:=UNDEF
    else if comm='UASSIGNUNDEF:D' then D:=UNDEF
    else if comm='UASSIGNUNDEF:E' then E:=UNDEF
    else if comm='UASSIGNMIN:E' then E:=0
    else if comm='UASSIGNMAX:E' then E:=UDPPSize+1
    else specialP310 := false;   { nenalezen vhodn pkaz }
end;

{ p303.iex: Implementace nestandardnch funkc interpretu specilnch
            pkaz k pkladu }

var
    UDL : tUDL;  { ADT dvojsmrn vzan linern seznam }



function specialP303 (var comm:tShortString; var comstr:string):boolean;
var i : integer;
begin
    specialP303 := true;                 { init }
    errflg := false;   { init - v een procedue nebyla oetovna chyba }
    if comm='UPRINTLISTGRAPH' then PrintListGraph(UDPP,UDL.first,UDL.act)
    else if comm='UNDEFLIST' then begin       { inicializace na UNDEF }
        UDL.first:=UNDEF;  UDL.last:=UNDEF;  UDL.act:=UNDEF;
        end
    else if comm='UPRINTADTLIST' then begin   { hodnoty ukazatel }
        write(fout,'LIST.first = ');  PrintNode(UDPP,UDL.first);
        write(fout,'LIST.last  = ');  PrintNode(UDPP,UDL.last);
        write(fout,'LIST.act   = ');  PrintNode(UDPP,UDL.act);
        end
    else if comm='UDLINIT' then UDLInit(UDL)
    else if comm='UDLINSERTFIRST' then begin
        GetIval(comstr,i);
        UDLInsertFirst(UDL,i);
        UndefNodes(UDPP);
        end
    else if comm='UDLFIRST' then UDLFirst(UDL)
    else if comm='UDLCOPY' then begin
        UDLCopy(UDL,i);
        if not errflg then writeln(fout,i);
        end
    else if comm='UDLSUCC' then UDLSucc(UDL)
    else if comm='UDLPRED' then UDLPred(UDL)
    else if comm='UDLDELETEFIRST' then begin
        UDLDeleteFirst(UDL);
        UndefNodes(UDPP);
        end
    else if comm='UDLPOSTDELETE' then begin
        UDLPostDelete(UDL);
        UndefNodes(UDPP);
        end
    else if comm='UDLPOSTINSERT' then begin
        GetIval(comstr,i);          { vkldan hodnota }
        UDLPostInsert(UDL,i);
        UndefNodes(UDPP);
        end
    else if comm='UDLACTUALIZE' then begin
        GetIval(comstr,i);          { nov hodnota }
        UDLActualize(UDL,i);
        UndefNodes(UDPP);
        end
    else if comm='UDLACTIVE' then writeln(fout,UDLActive(UDL))
    else if comm='UDLEMPTY' then writeln(fout,UDLEmpty(UDL))
    else specialP303 := false;   { nenalezen vhodn pkaz }
end;

{ p309.iex: Implementace nestandardnch funkc interpretu specilnch
              pkaz k pkladu (Petr Vurm, listopad 2000) }
const
    Cn2 = 'CZUS';
    Sc2 = '90';
    Cn8 = 'CZSKITSPRUPLFRGB';
    Sc8 = '10359104905487';
    Cn16 = '';
    Sc16 = '';


type
    ShortStr = string[80];
var
    USBRoot : tUNodePtr;  { koen stromu pro testovn }
    Score1, Score2 : integer; {pro test skre}
    j : integer; {na uchovani poctu zemi}


procedure USBPrintTree (var UDPP:tUDPP; RootPtr:tUNodePtr;
{         ------------} level:integer; sufix:ShortStr;
                        fromdir:char);  { 'L'eft, 'R'ight, 'X' = Root }
{ Tisk obsahu stromu s grafickm znzornnm jeho struktury. }
const MAXDEPTH=15;   { pedpokldan maximln hloubka stromu }
var
    ch : char;
    i : integer;
    AuxNode : tUNode;
begin
    if RootPtr<>UDPPNil then begin
        UDPPRead(UDPP,RootPtr,AuxNode); { nateme si obsah aktulnho uzlu }

        while (length(sufix)>0) and (sufix[length(sufix)]=' ') do
            delete(sufix,length(sufix),1); { zruit pravostrann mezery }

        if fromdir='R' then ch:='' else ch:=' ';
        USBPrintTree(UDPP,AuxNode.LPtr,level+1,ch+' '+sufix,'L');

        write(fout,AuxNode.Country1:4,'-',AuxNode.Country2,' ',
           AuxNode.Score1,':',AuxNode.Score2);
        for i:=1 to (MAXDEPTH-level)*2 do write(fout,' ');
        write(fout,'');

        if fromdir='L' then writeln(fout,' ',sufix)
        else if fromdir='R' then writeln(fout,' ',sufix)
        else writeln(fout,'[root]');

        if fromdir='L' then ch:='' else ch:=' ';
        USBPrintTree(UDPP,AuxNode.RPtr,level+1,ch+' '+sufix,'R');
        end;
end; { USBPrintTree }



function specialp309 (var comm:tShortString; var comstr:string):boolean;
var i : integer;
begin
    specialp309 := true;                { init }
    if comm='USBINIT' then USBInit(USBRoot)  { inicializace stromu }
    else if comm='USBPRINTTREE' then begin   { vytiskni strom (pascal DPP) }
        for i:=1 to 15 do write(fout,'');   writeln(fout);
        if USBRoot=UDPPNil then writeln(fout,'(root = nil)')
                           else USBPrintTree(UDPP,USBRoot,0,'','X');
        for i:=1 to 15 do write(fout,'');   writeln(fout);
        end
    else if comm='USBBUILDTREE' then
    begin
    getIval(comstr,j);
    case j of
    2:
      USBBuildTree(UDPP,USBRoot,Cn2,Sc2);
    8:
      USBBuildTree(UDPP,USBRoot,Cn8,Sc8);
    0:
      USBBuildTree(UDPP,USBRoot,'','');
    end
    end
    else if comm='USBCHAMPIONS' then write(fout,USBChampions(UDPP,USBRoot))
    else if comm='USBSCOREDIFF' then begin
      USBScoreDiff(UDPP,USBRoot,Score1,Score2);
      write(fout,'Vitezstvi: ',Score1);
      writeln(fout);
      write(fout,'Prohry:    ',Score2);
    end
    else if comm='USBDISPOSETREE' then begin  { zruen stromu }
        USBDisposeTree(UDPP,USBRoot);
        UndefNodes(UDPP);  { co by mohlo bt nedefinovan, nastav UNDEF }
        end
    else specialp309 := false;   { nenalezen vhodn pkaz }
end;



{************************* Funkce Interpretu *****************************}

{ prce se vstupem (soubor fin) ==========================================}

procedure CommandAssignInput (name:string);
{         ------------------
  Piad logickmu (globlnmu) souboru fin fyzick jmno 'name'.
  Jmno me obsahovat i plnou cestu k souboru.
  Soubor fin nesm bt oteven. }
var i : integer;
begin
    input_name := name;
    {$I-} close(fin); {$I+}    { zaveme, pokud byl oteven }
    i := IOResult;             { shodme intern pznak }
    {$I-} assign(fin,input_name); {$I+}
    if IOResult<>0 then
        Imsg('Nespn operace AssignInput '''+name+'''');
end;


procedure CommandResetInput;
{         -----------------
  Oteven souboru fin pro ten. }
begin
    {$I-} reset(fin); {$I+}
    if IOResult<>0 then begin
        Imsg('Nespn proveden pkazu ResetInput.');
        Imsg(' Existuje soubor '''+input_name+'''?');
        Imsg(' Byl ped ResetInput proveden pkaz AssignInput?');
        end;
end;


procedure CommandCloseInput;
{         -----------------
  Uzaven souboru fin -- napklad ped maznm souboru ped generovnm
  novho obsahu (EraseDataFile). }
var i : integer;
begin
    {$I-} close(fin); {$I+}
    i := IOResult;
end;


{ prce s vstupem (soubor fout) =========================================}

procedure CommandAssignOutput (name:string);
{         -------------------
  Piad logickmu (globlnmu) souboru fout fyzick jmno 'name'.
  Jmno me obsahovat i plnou cestu k souboru.
  Soubor fout nesm bt oteven. }
var i : integer;
begin
    output_name := name;
    {$I-} close(fout); {$I+}   { zaveme, pokud byl oteven }
    i := IOResult;             { shodme intern pznak }
    {$I-} assign(fout,output_name); {$I+}
    if IOResult<>0 then
        Imsg('Nespn operace AssignOutput '''+name+'''');
end;


procedure CommandRewriteOutput;
{         --------------------
  Oteven souboru fout pro zpis. }
var i : integer;
begin
    {$I-} close(fout); {$I+}   { nkdo mohl zapomenout zavt soubor }
    i := IOResult;             { shodme intern pznak }
    {$I-} rewrite(fout); {$I+}
    if IOResult<>0 then begin
        Imsg('Nespn proveden pkazu RewriteOutput.');
        Imsg(' Lze vytvoit soubor '''+input_name+'''?');
        Imsg(' Byl ped RewriteOutput proveden pkaz AssignOutput?');
        end;

end;


procedure CommandAppendOutput;
{         -------------------
  Oteven souboru fout pro zpis na konec souboru (append). }
var i : integer;
begin
    {$I-} close(fout); {$I+}   { nkdo mohl zapomenout zavt soubor }
    i := IOResult;             { shodme intern pznak }
    {$I-} append(fout);  if IOResult<>0 then rewrite(fout); {$I+}
    if IOResult<>0 then begin
        Imsg('Nespn proveden pkazu AppendOutput.');
        Imsg(' Existuje soubor '''+input_name+'''?');
        Imsg(' Lze jej ppadn vytvoit?');
        Imsg(' Byl ped AppendOutput proveden pkaz AssignOutput?');
        end;
end;


procedure CommandMsg (s:string);
{         ----------
 Vpis zprvy.  Pokud se poda, je vstup pesmrovn do fout.
 Pokud dojde k chyb pi zpisu, je vstup pesmrovn na obrazovku. }
begin
    {$I-} writeln(fout,s); {$I+}
    if IOResult<>0 then begin
        Imsg('Msg - nepodail se zpis do fout.');
        CommandConsole(s);
        end;
end;


procedure CommandMsgnoln (s:string);
{         --------------
 Vpis zprvy - pouze write.  Pokud se poda, je vstup pesmrovn do fout.
 Pokud dojde k chyb pi zpisu, je vstup pesmrovn na obrazovku.
 V tom ppad se po vpisu zprvy oddkuje. }
begin
    {$I-} write(fout,s); {$I+}
    if IOResult<>0 then begin
        Imsg('Msgnoln - nepodail se zpis do fout.');
        CommandConsole(s);
        end;
end;



{ prce s obecnm datovm souborem (generovn dat) ======================}

procedure CommandAssignDataFile (name:string);
{         ---------------------
  Nastav jmno datovho souboru.  Soubor fdata bv otevrn
  bezprostedn ped zpisem a uzavrn bezprostedn po zpisu (append). }
begin
    datafile_name := name;
end;


procedure CommandEraseDataFile;
{         --------------------
  Nehls se chyba, pokud se soubor nepoda smazat
  (pravdpodobn neexistuje). }
var i : integer;
begin
    if datafile_name<>'' then begin
        { Pi voln tto procedury je nutn zajistit, aby soubor byl
          uzaven. K problmm nedochz po vytven datovho souboru,
          protoe se vdy zavr. Pokud se ale soubor pouil jako
          vstupn (ResetInput), pak mohl zstat oteven a ped EraseDataFile
          je nutn jej zavt napklad volnm CloseInput }
        {$I-} assign(fdata,datafile_name); erase(fdata); {$I+}
        i := IOResult;   { shodme intern pznak }
        end;
end;


procedure CommandDataln (s:string);
{         -------------
 Vpis etzce do datovho souboru s ukonenm dku. }
begin
    if datafile_name='' then begin
        Imsg('Dataln - nebylo ureno jmno datovho souboru.');
        exit;
        end;

    assign(fdata,datafile_name);
    {$I-} append(fdata); if IOResult<>0 then rewrite(fdata); {$I+}
    if IOResult<>0 then begin
        Imsg('Dataln - soubor nelze otevt pro zpis:');
        Imsg(' '+datafile_name);
        Imsg(' '+s);
        end
    else begin
        writeln(fdata,s);
        CommandMsg(s);
        close(fdata);  { pokad zaveme }
        end;
end; { CommandDataln }


procedure CommandData (s:string);
{         -----------
 Vpis etzce do datovho souboru bez ukonen dku. }
begin
    if datafile_name='' then begin
        Imsg('Data - nebylo ureno jmno datovho souboru.');
        exit;
        end;

    assign(fdata,datafile_name);
    {$I-} append(fdata); if IOResult<>0 then rewrite(fdata); {$I+}
    if IOResult<>0 then begin
        Imsg('Data - soubor nelze otevt pro zpis:');
        Imsg(' '+datafile_name);
        Imsg(' '+s);
        end
    else begin
        write(fdata,s);
        CommandMsgnoln(s);
        close(fdata);  { pokad zaveme }
        end;
end; { CommandData }



{ prce s log-souborem (ladn, registrace chyb,...) =====================}

procedure CommandAssignLogFile (name:string);
{         --------------------
  Nastav jmno log-souboru.  Jmno log-souboru mus bt uvedeno bez cesty
  (log-soubor se vytv v pracovnm adresi).  Soubor flog bv otevrn
  bezprostedn ped zpisem a uzavrn bezprostedn po zpisu (append). }
begin
    log_name := name;
end;


procedure CommandEraseLogFile;
{         -------------------
  Nehls se chyba, pokud se soubor nepoda smazat
  (pravdpodobn neexistuje). }
var i : integer;
begin
    {$I-} assign(flog,log_name); erase(flog); {$I+}
    i := IOResult;    { shodme intern pznak }
end;


procedure CommandLog (s:string);
{         ----------
 Vpis zprvy do log-souboru. }
begin
    assign(flog,log_name);
    {$I-} append(flog); if IOResult<>0 then rewrite(flog); {$I+}
    if IOResult<>0 then begin
        CommandConsole('Log: Soubor '+log_name+' nelze otevt pro zpis.');
        CommandConsole(s);
        end
    else begin
        writeln(flog,s);
        close(flog);  { pokad zaveme }
        end;
end; { CommandLog }


{ miscelaneous ===========================================================}

procedure Imsg (msg:string);
{         ----
 Tato procedura se vol v ppad oznamovn chyby nebo varovn.
 Vype vizitka interpretu s udnm pozice ve skriptu, pi kter byla
 procedura vyvolna.  Zprva se vypisuje do fout, na obrazovku
 a do log-souboru.  Vdy vol CommandBeep. }
var
    s : string;
    sline : string;
    i : integer;
begin
    str(script_lnum,sline);      { slo dku ve skriptu }
    if script_name='' then
        s := 'INTERPRET: '
    else s := '('+script_name+':'+sline+') ';

    {$I-} writeln(fout,s,msg); {$I+}
    i := IOResult;  { shodme intern pznak }
    CommandConsole(s+msg);
    CommandLog(s+msg);
    CommandBeep;
end;  { Imsg }


procedure CommandBeep;
{         -----------
  Ppne, ale pouze beep_times krt za program. }
var
    d : integer;
    base : integer;
begin
    d := 30;
    base := 440;
    if beep_times>0 then begin
        if odd(beep_times) then begin sound(4*base); delay(d); end
                           else begin sound(3*base); delay(d); end;
        nosound;
        end;
    beep_times := beep_times - 1;
end;


procedure CommandConsole (s:string);
{         --------------
 Vpis na display. }
begin
    Writeln(stdout,s);  { nevypisuje na display pi
                          pesmrovn standardnho vstupu }
end;


procedure CommandEraseFile (s:string);
{         ----------------
  Smae zadan soubor, ppadn vce soubor zadanch maskou. }
var
    f : file;
    i : integer;
    DirInfo: SearchRec;  { pro FindFirst, FindNext }
begin
    FindFirst(s, Archive, DirInfo);
    while DosError=0 do begin
       {$I-} assign(f,DirInfo.Name); erase(f); {$I+}
       i := IOResult;  { shozen internho pznaku }
       FindNext(DirInfo);
       end;
end;


procedure CommandCommand (s:string);
{         --------------
  Spust COMMAND.COM a ped mu zadan etzec. }
begin
    if s<>'' then  begin
        s:='/C '+s;
        SwapVectors;
        Exec(GetEnv('COMSPEC'), s);
        SwapVectors;
        if DosError<>0
            then Imsg('Run - Nelze spustit COMMAND.COM');
        end;
end;


{ prce s uvedenm skriptem ==============================================}

procedure CommandScript (name:string);
{         -------------
  Oteve nov skript "name".  Pokud se neotevr hlavn skript,
  ukld se jmno pedchozho skriptu do zsobnku a soubor fscript
  se uzavr. }
var
    sptr : tScriptStatusPtr;
    i : integer;
    error : boolean;
begin
    { otestujeme ppustnost nzvu }
    trim(name);          { oeeme mezery }
    error := false;      { optimistick inicializace }

    if (pos('\',name)>0) or (pos(':',name)>0) then begin
        Imsg('Script - jmno souboru se zadv bez cesty (viz ScriptPath):');
        Imsg('        '''+name+'''');
        Imsg('        Tento pkaz se ignoruje.');
        error := true;
        end
    else begin
        { Otestujeme, zda skript nen voln rekurzivn.  Pi prvnm voln
          je hodnota promnn main_script_name nastavena na ''. }
        error := (name=main_script_name);
        sptr := script_stack;
        while not error and (sptr<>nil) do begin
            error := sptr^.script_name=name;
            sptr := sptr^.next;
            end;
        if error then begin
            Imsg('Script - rekurzivn voln skriptu '''+name+'''.');
            Imsg('        Pkaz se ignoruje.');
            end;
        end;

    if not error then begin
        { bylo zadno ppustn jmno skriptu }
        if main_script_name='' then begin
            { Jde o prvn voln, kter otevr hlavn skript.
              dn skript dosud nebyl oteven. }
            main_script_name := name;
            end
        else begin  { Njak skript ji byl oteven. }
            close(fscript);  { zaveme rozpracovan skript }
            new(sptr); { ulome nvratovou adresu rozpracovanho skriptu }
            sptr^.script_name := script_name;
            sptr^.script_lnum := script_lnum;
            sptr^.next := script_stack;
            script_stack := sptr;
            end;

        script_name := name; { jmno novho skriptu }
        script_lnum := 0;    { u novho skriptu zanme vdy od zatku }
        if not OpenScript then begin  { otevi nov skript }
            Imsg('Script - skript '''+script_name+''' se nepodailo otevt:');
            if script_name<>main_script_name then
                Imsg(' ScriptPath = '''+script_path+'''');
            Imsg('        Existuje takov soubor?');
            end;
        end; { if error else }
end; { CommandScript }


procedure CommandScriptPath (s:string);
{         -----------------
  Nastav cestu ke skriptm.  Pi prci s hlavnm skriptem se tato cesta
  ignoruje.  Cesta se neukld na zsobnk => pkaz lze pout jen
  v hlavnm skriptu a plat implicitn pro vechny ostatn skripty.
  Pokud cesta nekon zptnm lomtkem, je doplnno v ppad, e nen
  zadna przdn cesta (= vechny skripty se hledaj v pracovnm adresi,
  ve kterm se nachz tak hlavn skript). }
begin
    trim(s);
    if (length(s)>0) and (s[length(s)]<>'\') then s:=s+'\';
    if script_name<>main_script_name then begin
        Imsg('ScriptPath - lze pout pouze v hlavnm skriptu.');
        Imsg('            Zde se jeho vskyt ignoruje.')
        end
    else  script_path := s;  { nov cesta spn nastavena }
end;


procedure CommandReturn;
{         -------------
  Provede nvrat k pedchozmu skriptu. }
var
    i : integer;
    sptr : tScriptStatusPtr;
begin
    { Pokud existuje odloen pedchoz skript, uzavi souasn skript,
      otevi pedchoz a nastav se na msto, odkud se m pokraovat }
    if script_stack<>nil then begin
        close(fscript);                           { uzavi souasn skript }
        script_name := script_stack^.script_name; { parametry pvodnho    }
        script_lnum := script_stack^.script_lnum;
        sptr := script_stack;               { odstra poloku ze zsobnku }
        script_stack := script_stack^.next;
        dispose(sptr);

        { otevi pvodn skript a pesko ji zpracovan dky }
        if not OpenScript then begin
            Imsg('Return - pvodn skript '''+script_name+
                  '''se nepodailo znovu otevt.');
            end
        else    { podailo se otevt, najdi sprvnou pozici (dek) }
            for i:=1 to script_lnum do readln(fscript);
        end { if neprzdn zsobnk then }
    else
        CommandQuit; { explicitn (nebo implicitn) return v hlavnm skriptu }
end;  { CommandReturn }


procedure CommandQuit;
{         -----------
  Ukon interpretaci vech skript. }
var
    sptr : tScriptStatusPtr;
    i : integer;
begin
    { zrume zsobnk skript }
    while script_stack<>nil do begin
        sptr := script_stack;
        script_stack := script_stack^.next;
        dispose(sptr);
        end;

    { pokud byl njak skript oteven, tak jej zaveme }
    {$I-} close(fscript); {$I+}
    i := IOResult;  { shodme intern pznak }

    quit_interpret := true;   { a se vichni dozv tu hroznou novinu :-) }
end;


{ konstrukce =============================================================}

procedure CommandFor (ch:char; i,j:integer; comstr:string);
{         ----------
  V rozsahu mez i, j provede pkaz(y) comstr.
  Odpovd pascalovskmu FOR...TO... Ped kadm provedenm pkazu
  z comstr jsou v nm vechny vskyty znaku ch nahrazeny (textov)
  aktuln hodnotou indexu. }
var
    index : integer;        { promnn cyklu }
    sindex : string;        { textov podoba hodnoty promnn cyklu }
    n : integer;            { aux }
    s : string;
    cn : integer;
begin
    for index:=i to j do begin
        str(index,sindex);      { textov podoba hodnoty indexu }
        s := '';                { init: commstr-->s pi nhrad ch }
        for n:=1 to length(comstr) do
            if comstr[n]=ch then s:=s+sindex      { nahrazen }
                            else s:=s+comstr[n];  { pouh okoprovn znaku }
        command(s);  { prove pkaz s nahrazenmi znaky }
        end;
end; { CommandFor }


procedure CommandForDown (ch:char; i,j:integer; comstr:string);
{         ----------
  V rozsahu mez i, j provede pkaz(y) comstr.
  Odpovd pascalovskmu FOR...DOWNTO... Ped kadm provedenm pkazu
  z comstr jsou v nm vechny vskyty znaku ch nahrazeny (textov)
  aktuln hodnotou indexu. }
var
    index : integer;        { promnn cyklu }
    sindex : string;        { textov podoba hodnoty promnn cyklu }
    n : integer;            { aux }
    s : string;
    cn : integer;
begin
    for index:=i downto j do begin
        str(index,sindex);      { textov podoba hodnoty indexu }
        s := '';                { init: commstr-->s pi nhrad ch }
        for n:=1 to length(comstr) do
            if comstr[n]=ch then s:=s+sindex      { nahrazen }
                            else s:=s+comstr[n];  { pouh okoprovn znaku }
        command(s);  { prove pkaz s nahrazenmi znaky }
        end;
end; { CommandForDown }


procedure CommandForEnum (ch:char; var enum:string; comstr:string);
{         --------------
  Provede length(enum) cykl, kdy ped kadm provedenm pkazu
  z comstr jsou v nm vechny vskyty znaku ch nahrazeny znakem enum[index]. }
var
    index : integer;        { promnn cyklu }
    n : integer;            { aux }
    s : string;
    cn : integer;
begin
    for index:=1 to length(enum) do begin
        s := '';                { init: commstr-->s pi nhrad ch }
        for n:=1 to length(comstr) do
            if comstr[n]=ch then s:=s+enum[index] { nahrazen }
                            else s:=s+comstr[n];  { pouh okoprovn znaku }
        command(s);  { prove pkaz s nahrazenmi znaky }
        end;
end; { CommandForEnum }


{ natn parametr pkaz =============================================}

function GetError : boolean;
{        --------
  Test na chybu pi Get?val. }
begin
   GetError := GetErrorFlag<>' ';
   GetErrorFlag := ' ';
end;


procedure GetSval (var getstr:string; var sval:string);
{         -------
  Zsk parametr typu string a odstran jej z getstr. Ped natnm
  testuje GetErrorFlag a nepracuje, pokud nebyla pedchoz funkce oetena
  pomoc GetError.  Pi chyb se GetErrorFlag nastavuje na 'S'. }
var
    p1, p2 : integer;
    konec : boolean;
begin
    if GetErrorFlag=' ' then begin
        trim(getstr);              { odstranit mezery }
        if (length(getstr)=0) or (getstr[1]<>'''') then begin
            Imsg('GETSVAL - oekv se etzec  '+getstr);
            GetErrorFlag := 'S';
            end
        else begin
            p1 := 2; { prvn znak etzce }
            p2 := 2; { init }
            konec := false;
            while not konec do begin
                while (p2<=length(getstr)) and (getstr[p2]<>'''') do p2:=p2+1;
                if p2>length(getstr) then begin
                    { nenael se ukonujc apostrof }
                    Imsg('GETSVAL - chybn ukonen etzec  '+getstr);
                    GetErrorFlag := 'S';
                    konec := true;   { konme vyhledvn druh hranice }
                    end
                else if (p2<length(getstr)) and (getstr[p2+1]='''') then begin
                    { zdvojen apostrof se mus zjednoduit }
                    delete(getstr,p2,1);
                    p2 := p2+1;         { budeme pokraovat ve vyhledvn }
                    end
                else if p2<=length(getstr) then konec := true;
                                        { tento apostrof ukonuje etzec }
                end; { while not konec }
            sval := copy(getstr,p1,p2-p1);      { hledan hodnota parametru }
            delete(getstr,1,p2);                { odstranit naten parametr }
            end;
        end
    else Imsg('GETSVAL - vskyt neoeten chyby ('+GetErrorFlag+')');
end; { GetSval }


procedure GetIval (var getstr:string; var ival:integer);
{         -------
  Zsk parametr typu integer a odstran jej z getstr.  Ped natnm
  testuje GetErrorFlag a nepracuje, pokud nebyla pedchoz funkce oetena
  pomoc GetError.  Pi chyb se GetErrorFlag nastavuje na 'I'. }

var
    p, code : integer;
    s : string;
begin
    if GetErrorFlag=' ' then begin
        trim(getstr);        { odstranit mezery }
        if length(getstr)=0 then begin
            Imsg('GETIVAL - oekv se parametr typu integer.');
            GetErrorFlag := 'I';
            end
        else begin
            p := pos(' ',getstr);
            if p=0 then p:=length(getstr)+1;        { za konec sla }
            s := copy(getstr,1,p-1);      { textov podoba parametru }
            val(s,ival,code);             { ival = integer podoba }
            if code<>0 then begin
                Imsg('GETIVAL - oekv se slo typu integer  '+s);
                GetErrorFlag := 'I';
                end;
            delete(getstr,1,p);           { odstranit zpracovan parametr }
            end
        end
    else Imsg('GETIVAL - vskyt neoeten chyby ('+GetErrorFlag+')');
end; { GetIval }


procedure GetCval (var getstr:string; var ch:char);
{         -------
  Zsk parametr typu char (nen omezen apostrofy) a odstran jej z getstr.
  Ped natnm testuje GetErrorFlag a nepracuje, pokud nebyla
  pedchoz funkce oetena pomoc GetError.  Pi chyb se GetErrorFlag
  nastavuje na 'C'. }
begin
    if GetErrorFlag=' ' then begin
        trim(getstr);        { odstranit mezery }
        if length(getstr)=0 then begin
            Imsg('GETCVAL - oekv se parametr typu znak.');
            GetErrorFlag := 'C';
            end
        else begin
            ch := getstr[1];
            delete(getstr,1,1);           { odstranit zpracovan parametr }
            end
        end
    else Imsg('GETCVAL - vskyt neoeten chyby ('+GetErrorFlag+')');
end; { GetCval }


procedure GetRval (var getstr:string; var rval:real);
{         -------
  Zsk parametr typu real a odstran jej z getstr.  Ped natnm
  testuje GetErrorFlag a nepracuje, pokud nebyla pedchoz funkce oetena
  pomoc GetError.  Pi chyb se GetErrorFlag nastavuje na 'R'. }

var
    p, code : integer;
    s : string;
begin
    if GetErrorFlag=' ' then begin
        trim(getstr);        { odstranit mezery }
        if length(getstr)=0 then begin
            Imsg('GETRVAL - oekv se parametr typu real.');
            GetErrorFlag := 'R';
            end
        else begin
            p := pos(' ',getstr);
            if p=0 then p:=length(getstr)+1;        { za konec sla }
            s := copy(getstr,1,p-1);      { textov podoba parametru }
            val(s,rval,code);             { rval = real podoba }
            if code<>0 then begin
                Imsg('GETRVAL - oekv se slo typu real  '+s);
                GetErrorFlag := 'R';
                end;
            delete(getstr,1,p);           { odstranit zpracovan parametr }
            end
        end
    else Imsg('GETRVAL - vskyt neoeten chyby ('+GetErrorFlag+')');
end; { GetRval }



{ pomocn procedury a funkce =============================================}

procedure InitGlobVar;
{         -----------  Inicializace globlnch promnnch }
begin
    input_name := '';      { fin; '' znamen z klvesnice }
    output_name := '';     { fout; '' znamen na display  }

    script_path := '';     { cesta ke vem skriptm }
    script_name := '';     { pln jmno souboru se skriptem   }
    script_lnum := 0;      { slo aktulnho dku ze skriptu }
    script_stack := nil;   { inicializace zsobnku nvratovch adres }
    main_script_name := '';  { init - neexistujc jmno skriptu (hlavn
                             skript nesm bt zadvn z klvesnice; tento
                             stav oetuje procedura Interpret)}

    log_name := IMPLICIT_LOG_NAME; { implicitn jmno log-souboru  }

    datafile_name := '';   { nedefinovan jmno datovho souboru }

    beep_times := 10;              { beep ppne maximln tolikrt }

    int_val := 0;          { globln promnn interpretu typu integer }
    str_val := '';         { globln promnn interpretu typu string  }
    bool_val := false;     { globln promnn interpretu typu boolean }
    heap_size := MemAvail; { celkov velikost heap }
    mark_heap := 0;        { implicitn UsedHeapRel = UsedHeapAbs }
    GetErrorFlag := ' ';   { zatm dn chyba pi Get?val }
end;


procedure trim (var s:string);
{         ----
 Odstran vodn mezery, tabultory a koment od COMMENTCH do konce dku.
 Pi hledn zatku komente nereaguje na obsahy etzc.
 Na zvr odstran koncov mezery a tabultory. }
var
    i, n : integer;
    instr : boolean;  { true <=> nachzme se v 'etzci' }
    konec : boolean;
begin
    { odstranit vodn mezery a tabultory }
    while (pos(' ',s)=1) or (pos(#9,s)=1) do  delete(s,1,1);

    n := length(s)+1;  { init - fiktivn pozice zatku komente }
    instr := false;    { init - mimo etzec }
    i := 1;            { budeme testovat prvn pozici }

    konec := i>length(s);
    while not konec do begin
        if s[i]='''' then                     { zatek nebo konec 'str' }
            instr := not instr
        else if not instr and (s[i]=COMMENTCH) then
            n := i;                           { poten pozice komente }
        { ostatn znaky ignorujeme }
        konec := n=i;      { pozice (ppadn fiktivn) zatku komente? }
        i := i+1;
        end;
    s := copy(s,1,n-1);    { kopruj pouze znaky ped komentem }

    { odstranit koncov mezery a tabultory }
    n := length(s);
    while n>0 do begin
        if (s[n]=' ') or (s[n]=#9) then begin
            delete(s,n,1);
            n := n - 1;
            end
        else n:=0;       { ani mezera, ani tabultor => ukonen cyklu }
        end;
end; { trim }


function OpenScript : boolean;
{        ----------
  Oteve skript script_path\script_name s tm, e u main_script_name
  nepidv script_path.  Vrac true, pokud se skript podailo otevt. }
var sname : string;
begin
    OpenScript := true;  { optimistick inicializace }
    sname := script_name;
    if script_name<>main_script_name then sname:=script_path+sname;
    {$I-} assign(fscript,sname); reset(fscript); {$I+}
    if IOResult<>0 then begin
        OpenScript := false;
        CommandQuit;
        end;
end;


{ due a tlo interpretu =================================================}

procedure SeparateCommand (var comstr:string; var comm:tShortString);
{         ---------------
 Oddl z comstr prvn etzec znak ukonen mezerou (pkaz),
 ulo jej do comm a odstran jej z comstr.  Odstran koment
 a nadbyten a vodn mezery, pkaz v comm pevede na velk psmena. }
var i : integer;
begin
    trim(comstr);  { oznout vodn mezery a koment }
    i := pos(' ',comstr)-1;        { dlka nzvu pkazu }
    if i<0 then i:=length(comstr); { mon pkaz bez parametr }
    comm := copy(comstr,1,i);      { jmno pkazu }
    delete(comstr,1,i+1); { v comstr zbudou jen parametry a dal pkazy }
    for i:=1 to length(comm) do comm[i]:=upcase(comm[i]);      { na VELK }
end;


procedure command (var comstr:string);
{         ------- interpretace jednoho pkazu v comstr }
var
    comm : tShortString;      { jmno pkazu zskan z comstr }
    i,j,k,n : integer;        { doasn promnn vyuvan v rmci }
    s : string;               { ...interpretace jednoho pkazu    }
    sshort : tShortString;
    ch : char;
    il : longint;
begin
    while comstr<>'' do begin
        SeparateCommand(comstr,comm); { oddlen pkazu a zbytku }

        { przdn dky (mohl to bt i koment) ---------------------------}
        if      comm='' then exit   { przdn dky peskakujeme }

        { prce se vstupem -------------------------------------------------}
        else if comm='ASSIGNINPUT' then begin  { uren fyz. jmna fin:text }
            GetSval(comstr,s);                 { fyzick jmno souboru }
            if not GetError then CommandAssignInput(s);
            end
        else if comm='RESETINPUT' then CommandResetInput { oteven fin:text }
        else if comm='CLOSEINPUT' then CommandCloseInput { uzaven fin:text }

        { prce s vstupem -------------------------------------------------}
        else if comm='ASSIGNOUTPUT' then begin  { uren jmna fout:text }
            GetSval(comstr,s);                  { fyzick jmno souboru }
            if not GetError then CommandAssignOutput(s);
            end
        else if comm='REWRITEOUTPUT' then CommandRewriteOutput { fout:text }
        else if comm='APPENDOUTPUT' then CommandAppendOutput { append fout }
        else if comm='MSG' then begin                        { zprva      }
            CommandMsg(comstr);
            comstr := '';  { cel zbytek dku zpracovn }
            end
        else if comm='MSGNOLN' then begin        { zprva bez konce dku  }
            GetSval(comstr,s);
            if not GetError then CommandMsgnoln(s);
            end
        else if comm='NEWLINE' then CommandMsg('')  { nov dek na vstup }
        else if comm='WRITESCRIPTNAME' then begin   { vypi zadan text... }
            GetSval(comstr,s);                      { ... a jmno skriptu  }
            if not GetError then CommandMsg(s+script_name);
            end

        { prce s log-souborem ---------------------------------------------}
        else if comm='ASSIGNLOGFILE' then begin  { jmno log-souboru }
            GetSval(comstr,s);               { fyzick jmno souboru }
            if not GetError then CommandAssignLogFile(s);
            end
        else if comm='ERASELOGFILE' then 
	    CommandEraseLogFile                      { smazat log-soubor }
        else if comm='LOG' then begin                      { do log-file }
            CommandLog(comstr);
            comstr := '';  { cel zbytek dku zpracovn }
            end

        { prce s datovm souborem -----------------------------------------}
        else if comm='ASSIGNDATAFILE' then begin  { jmno souboru s daty    }
            GetSval(comstr,s);                    {  fyzick jmno souboru  }
            if not GetError then CommandAssignDataFile(s);
            end
        else if comm='ERASEDATAFILE' then 
	    CommandEraseDataFile                  { smazat datov soubor    }
        else if comm='DATALN' then begin          { s koncem dku          }
            GetSval(comstr,s);
            if not GetError then CommandDataln(s);
            end
        else if comm='DATA' then begin            { bez konce dku         }
            GetSval(comstr,s);
            if not GetError then CommandData(s);
            end
        else if comm='DATAEOL' then begin         { data do konce dku     }
            CommandDataln(comstr);
            comstr := '';  { cel zbytek dku zpracovn }
            end

        { prce s terminlem -----------------------------------------------}
        else if comm='CON' then begin             { na display  }
            CommandConsole(comstr);
            comstr := '';  { cel zbytek dku zpracovn }
            end
        else if comm='BEEPTIMES' then begin { nastav maximln poet ppnut }
            GetIval(comstr,beep_times);
            if not GetError then
                if beep_times<0 then beep_times:=0; { kvli comm='BEEP' }
            end
        else if comm='BEEP' then begin   { ppne vdy, bez ohledu beep_times }
            i := beep_times;
            beep_times := 2;            { 1/2 vka ppnut (viz CommandBeep }
            CommandBeep;
            beep_times := i;
            end

        { vstup/vstup vnitn hodnoty -------------------------------------}
        { Nsledujc pkazy nastavuj hodnoty implicitn urench
          globlnch promnnch. }
        else if comm='SETBOOL' then begin      { nastav boolean; 0=false }
            GetIval(comstr,i);
            if GetError then Imsg('SetBool - oekv se slo.')
                        else bool_val:=i<>0;
            end
        else if comm='SETINT' then begin
            GetIval(comstr,int_val);  { nastav integer }
            if GetError then Imsg('SetInt - oekv se slo.');
            end
        else if comm='SETSTR' then begin
            GetSval(comstr,str_val); { nastav string  }
            if GetError then Imsg('SetStr - oekv se etzec.');
            end

        { Nsledujc pkazy vypisuj hodnoty implicitn urench globlnch
          promnnch.  Po vpisu hodnoty je vypsna mezera a nen proveden
          pechod na nov dek (v ppad poteby se pouv explicitn
          NEWLINE). }
        else if comm='WRITEBOOL' then begin    { vypi bool_val }
            if bool_val then s:='true'  else s:='false';
            CommandMsgnoln(s+' ');
            end
        else if comm='WRITEINT' then begin     { vypi integer }
            str(int_val:5,s);
            CommandMsgnoln(s+' ');
            end
        else if comm='WRITESTR' then           { vypi string }
            CommandMsgnoln(str_val+' ')

        { konstrukce -------------------------------------------------------}
        else if comm='IF' then begin      { if bool_val then command-string }
            if bool_val then command(comstr);
            end
        else if comm='IFNOT' then begin      { if not bool_val then commstr }
            if not bool_val then command(comstr);
            end
        else if (comm='FOR') or (comm='FORDOWN')
                or (comm='FORENUM') then begin
            {  1. "For CH i1 i2 command_string", kde CH je libovoln vhodn
                  znak (bez apostrof).  Vechny vskyty znaku CH v comstr
                  budou nahrazeny textovou reprezentac hodnoty promnn cyklu.
                  Smanticky odpovd pascalovskmu potanmu cyklu
                  "for i1 to i2 do".

               2. "ForDown CH i1 i2 command_string" - parametry jako
                  v pedchozm ppad.  Smanticky odpovd pascalovskmu
                  potanmu cyklu "for i1 downto i2 do".

               3. "ForEnum CH 'abcd' command_string", kde CH je libovoln
                  vhodn znak (bez apostrof).  Vechny vskyty znaku CH
                  v comstr budou postupn nahrazeny znaky 'abcd'.
            }
            GetCval(comstr,ch);             { zjistme nahrazovan znak }
            if GetError then Imsg(' ForXXX - oekval se nahrazovan znak.')
            else if (ch=' ') or (ch=#9) then begin
                Imsg(' ForXXX - znak '' '' m vznam oddlovae.');
                Imsg('          Implicitn nhrada ''#''');
                ch := '#';
                end
            else if ch=COMMENTCH then begin
                Imsg(' ForXXX - znak '''+COMMENTCH+''' uvozuje poznmku.');
                Imsg('          Implicitn nhrada ''#''');
                ch := '#';
                end
            else if ch='''' then begin
                Imsg(' ForXXX - znak <apostrof> ohraniuje etzec.');
                Imsg('          Implicitn nhrada ''#''');
                ch := '#';
                end
            else if comm='FOR' then begin     { ==== potan cyklus }
                GetIval(comstr,i);            { nateme hranice cyklu }
                if not GetError then GetIval(comstr,j);
                if not GetError then CommandFor(ch,i,j,comstr);
                end
            else if comm='FORDOWN' then begin { ==== potan cyklus (downto)}
                GetIval(comstr,i);            { nateme hranice cyklu }
                if not GetError then GetIval(comstr,j);
                if not GetError then CommandForDown(ch,i,j,comstr);
                end
            else if comm='FORENUM' then begin  { ==== cyklus pes vet }
                GetSval(comstr,s);             { nateme vet }
                if not GetError then CommandForEnum(ch,s,comstr);
                end;
            comstr := '';  { ve za for bylo zpracovno}
            end

        { sledovn stavu Heap ---------------------------------------------}
        { Poznmka: Interpret rovnا vyuv Heap -- nsledujc pkazy
          pouvat s ohledem na to, e si Interpret pidluje pam؜ vdy
          pi otvrn novho skriptu (pkaz Script) a uvoluje ji opt
          po uzaven skriptu (implicitn nebo explicitn Return). }
        else if comm='HEAPMARK' then begin    { nastaven relativn hranice }
            mark_heap := heap_size-MemAvail;
            str(mark_heap:7,sshort);
            s := 'Nastavena relativn hranice na Heap: '+sshort;
            CommandMsg(s);
                { Poznmka: Vpis seln hodnoty mark_heap byl pokusn na
                  chvli zruen, ale ukzalo se, e umouje odhalit chybnou
                  inicializaci nebo jinou chybnou prci s dynamickm 
                  pidlovnm pamti v aktulnm nebo pedchozch pkladech.
                }
            end
        




        else if comm='HEAPUSEDREL' then begin   { pouit prostor relativn }
            str(heap_size-MemAvail-mark_heap:7,sshort);
            s := 'Pouit prostor na Heap (relativn): '+sshort;
            CommandMsg(s);
            end
        else if comm='HEAPUSEDABS' then begin   { pouit prostor absolutn }
            str(heap_size-MemAvail:7,sshort);
            s := 'Pouit prostor na Heap (absolutn): '+sshort;
            CommandMsg(s);
            end
        else if comm='HEAPAVAIL' then begin    { voln prostor }
            str(MemAvail:7,sshort);
            s := 'Momentln voln prostor na Heap   : '+sshort;
            CommandMsg(s);
            end
        else if comm='HEAPSIZE' then begin     { celkov velikost heap }
            str(heap_size:7,sshort);
            s := 'Celkov velikost pamti pro Heap   : '+sshort;
            CommandMsg(s);
            end

        {--------------------- speciality ----------------------------------}
        else if comm='ERASEFILE' then begin    { smazat soubor(y) }
            GetSval(comstr,s);                 { maska }
            if not GetError then CommandEraseFile(s);
            end
        else if comm='SCRIPTPATH' then begin  { nastaven cesty ke skriptm }
            GetSval(comstr,s);
            if not GetError then CommandScriptPath(s);
            end
        else if comm='SCRIPT' then begin          { oteven novho skriptu }
            GetSval(comstr,s);
            if not GetError then CommandScript(s);
            end
        else if comm='RETURN' then           { nvrat k pedchozmu skriptu }
            CommandReturn
        else if comm='QUIT' then      { nsiln ukonen interpretace veho }
            CommandQuit
        else if comm='COMMAND' then begin  { spus command.com s parametry }
            GetSval(comstr,s);
            if not GetError then CommandCommand(s);
            end

        {------- speciln pkaz pro interpretaci nkterho z pklad ------}
else if specialP301(comm,comstr) then { OK => nic }
else if specialP310(comm,comstr) then { OK => nic }
else if specialP303(comm,comstr) then { OK => nic }
else if specialP309(comm,comstr) then { OK => nic }
        else begin
            Imsg('Neoekvan pkaz.');
            Imsg(' Pkaz      : '''+comm+'''');
            Imsg(' Zbytek dku: '''+comstr+'''');
            Imsg(' (oba ve uveden daje jsou uzaveny v apostrofech)');
            end;
        if not solved then begin
            CommandMsg(' Procedura/funkce nebyla implementovna. ');
            CommandReturn;     { ukonme }
            solved := true;    { optimistick pedpoklad - p een bude }
            end;
        end; { while comstr<>'' }
end; {command}


procedure Interpret (scr_name:tShortString);
{         ---------
  Interpretace skriptu scr_name. }
var
    i : integer;
    s : string;
    konec : boolean;
begin
    quit_interpret := false;      { init }
    if scr_name='' then begin     { jmno hlavnho skriptu }
        Imsg('Hlavn skript mus bt fyzick soubor.');
        Imsg(' Pedasn ukonen interpretu.');
        exit;
        end;

    CommandScript(scr_name);       { hlavnm skriptem zaneme }

    while not quit_interpret do begin
        konec := eof(fscript);
        while not konec do    { do konce kadho skriptu }
            begin
            readln(fscript,s);
            script_lnum := script_lnum+1;
            command(s);       { interpretuj dek skriptu }
            { mohlo dojt k zaven fscript}
            {$I-} konec := eof(fscript); {$I+}
            if IOResult<>0 then  { nen oteven dn skript, konec }
                konec := true;
            end;

        if not quit_interpret then
            CommandReturn;    { implicitn nvrat do pedchozho skriptu }
        end;              { ...nebo nic pro hlavn skript }

    { zaveme vechno, co jde (soubory :-) }
    {$I-} Close(fscript); Close(fout); Close(fin); {$I+}
    i := IOResult;  { shodme intern pznak }
end;  { Interpret }



begin  { tlo celho programu }
    InitGlobVar;      { inicializace globlnch promnnch  }
    assign(stdout,'');
    rewrite(stdout);
    solved := true;
    { Pokud je vyhodnocovn pkaz, kter vol proceduru nebo funkci
      eenho pkladu (nkter pkazy interpret specilnch pkaz),
      pedpokldme, e byl een.  Pokud ne, vrt se po proveden
      specilnho pkazu hodnota solved=false.  Na konci procedury command
      je tato situace oetena a promnn solved je opt nastavena na true. }
    if ParamCount<1 then
        Interpret('intrpret.scr')   { implicitn jmno hlavnho skriptu }
    else
        Interpret(ParamStr(1));     { zadan jmno skriptu }
    close(stdout);
end.
