{* ukol_4.pas: een kolu ukol_4
** Datum odevzdn (deadline): nedle 6. kvtna 2001 do 24:00
** (tento soubor byl vygenerovn automaticky skriptem novyukol.pl) }
{* p401.pas: **********************************************************}
{* Tma: Rekurzivn implementace operac nad BVS (pascalovsk DPP)
**                           Vytvoil: Petr Pikryl, listopad 1994
**                           pravy:   Andrea Nmcov, prosinec 1995
**                                     Petr Pikryl, duben 1996
**                                     Petr Pikryl, listopad 1997
**
** Implementujte rekurzivnm zpsobem operace nad binrnm vyhledvacm
** stromem (BVS; v anglitin BST -- Binary Search Tree).
**
** Klem uzlu stromu je jeden znak (obecn jm me bt cokoliv, podle
** eho se vyhledv). Uitenm (vyhledvanm) obsahem je zde etzec.
** Uzly s menm klem le vlevo, uzly s vtm klem le ve stromu
** vpravo. Vyuijte pascalovskho dynamickho pidlovn pamti.
** Rekurzivnm zpsobem ete nsledujc procedury a funkce:
**
**   BSTInit ...... inicializace vyhledvacho stromu
**   BSTSearch .... vyhledvn hodnoty uzlu zadanho klem
**   BSTInsert .... vkldn nov hodnoty
**   BSTDelete .... ruen uzlu se zadanm klem
**   BSTDispose ... ruen celho stromu
**
** Pesnou definici typ naleznete v souboru p401.ifc; pro pehled --
** ADT BVS je reprezentovno koenovm ukazatelem stromu typu tBSTNodePtr.
** Uzel stromu (zznam typu tBSTNode) obsahuje ukazatele LPtr a RPtr na lev
** a prav podstrom, sloku Key:char -- kl, podle kterho se vyhledv,
** a Cont:tBSTCont -- obsah uzlu (krtk etzec).
**
** Poznmka: nepouvejte nestandardn pkazy (exit,...) a operace.
** Nepouvejte pepnae kompiltoru.
**
** Anglitina:
**       binary [bain@ri] = binrn, dvojit, podvojn
**       search [s@:] = vyhledvat, vyhledvac
**       tree [tri:] = strom
**       pointer (Ptr) [pointr] = ukazatel
**       root [ru:t] = koen
**       node [noud] = uzel
**       key [ki:] = kl
**       content [kontent] = obsah
**       true [tru:] = pravda, pravdiv
**       false [fo:ls] = klamn, nepravdiv
**       insert [in's@:t] = vloit
**       delete [dili:t] = vypustit
**       dispose [dis'pouz] = zruit
**}

{*}procedure BSTInit (var RootPtr: tBSTNodePtr);
{*           -------
** Poten inicializace stromu ped prvnm pouitm datov struktury.
** Poten testovn ukazatele nen mon, protoe obsahuje nedefinovanou
** (tj. libovolnou) hodnotu, kter ovem neodr reln stav.
**}
begin
    RootPtr := nil;
end;


{*}function BSTSearch (RootPtr:tBSTNodePtr;
{*          ---------} K:char; var Content:tBSTCont) : boolean;
{*
** Vyhledvn uzlu v BVS podle zadanho kle K. Pokud je nalezen, vrac
** funkce hodnotu True a v promnn Content se vrac obsah pslunho uzlu.
** Pokud pslun uzel nen nalezen, vrac funkce hodnotu False a obsah
** promnn Content nen definovn (to znamen, e do n nebudete nic
** piazovat). Pi vyhledvn v binrnm stromu bychom typicky pouili
** cyklus ukonen testem zahrnujcm stav dosaen listu nebo nalezen
** uzlu s klem. V tomto ppad ovem test nepouijte a problm ete
** rekurzivnm voln tto funkce (nedeklarujte dnou pomocnou proceduru
** nebo funkci).
**}
begin
    if RootPtr = nil {nachz se na listu, ale kl nebyl nalezen} then
        BSTSearch := False
    else begin
        if RootPtr^.Key = K {kl nalezen} then begin
            BSTSearch := True;
            Content := RootPtr^.Cont;
            end {if}
        else begin
            if RootPtr^.Key > K then {pokrauj v levm podstromu}
                BSTSearch := BSTSearch(RootPtr^.LPtr, K, Content)
            else {pokrauj v pravm podstromu}
                BSTSearch := BSTSearch(RootPtr^.RPtr, K, Content);
            end {else};
        end {else};
end;


{*}procedure BSTInsert (var RootPtr:tBSTNodePtr; K:char; Content:tBSTCont);
{*           ---------
** Vlo do stromu hodnotu Content s klem K. Pokud ji uzel
** se zadanm klem existuje, nahrad se obsah uzlu novou hodnotou.
** Nov vytvoen uzel nech je vdy listem stromu. ete rekurzivn.
**
** Tato rekurzivn implementace je ponkud neefektivn, protoe se pi
** kadm rekurzivnm zanoen mus koprovat cel etzec "Content" (obecn
** obsah uzlu). V praxi by se tento problm eil napklad jednm
** z tcho zpsob:
**  - pedvnm promnn "Content" odkazem (v tom ppad je nutn dosazovat
**    pi voln promnnou a nen mon pmo zapsat hodnotu);
**  - deklarac vnitn procedury, kter by se parametr pedal odkazem;
**    vnj procedura by slouila jen jako obal (nevolala by se
**    rekurzivn);
**  - pi vyuit pedchoz varianty by se do rekurzivn procedury pedval
**    pedem naplnn nov uzel, kter by se na zvr zruil v ppad,
**    e se uzel nepodailo zaadit (pokud u uzel s tmto klem existoval,
**    pepsal by se jen obsah, ppadn by se uzly vymnily a ke zruen
**    by se pedal star uzel);
**
** Nerekurzivn varianta by v tomto ppad byla efektivnj jak z hlediska
** rychlosti, tak z hlediska pam؜ovch nrok. Zde vak jde o koln
** pklad. Nedeklarujte dnou pomocnou proceduru nebo funkci, probm
** ete rekurzivnm volnm procedury sam.
**}
begin
    if RootPtr = nil {na pozici listu je mono nov uzel vloit} then begin
        New(RootPtr);
        with RootPtr^ do begin
            Key := K;
            Cont := Content;
            LPtr := nil;
            RPtr := nil;
            end {with};
        end {if}
    else begin
        if K < RootPtr^.Key then {pokrauj v levm podstromu}
            BSTInsert(RootPtr^.LPtr, K, Content)
        else if K > RootPtr^.Key then {pokrauj v pravm podstromu}
            BSTInsert(RootPtr^.RPtr, K, Content)
        else {aktualizuj hodnotu uzlu}
            RootPtr^.Cont := Content;
        end {else};
end;


{*}procedure BSTDelete (var RootPtr:tBSTNodePtr; K:char);
{*           ---------
** Zru uzel stromu, kter obsahuje kl K. Pokud uzel se zadanm klem
** neexistuje, nedl nic. Veker manipulace ete rekurzivn.
**
** Pokud m ruen uzel jen jeden podstrom, pak jej zdd otec. Pokud m
** oba podstromy, pak je ruen uzel nahrazen nejpravjm uzlem levho
** podstromu. Pozor! Nejpravj uzel nemus bt listem. Pro tuto operaci
** budeme deklarovat lokln proceduru ReplaceByRightmost -- viz dle.
**
** Pomocn ukazatel typu tBSTNodePtr, kter budete pi een potebovat,
** nazvte ptr.
**}

{*}procedure ReplaceByRightmost (PtrReplaced:tBSTNodePtr;
{*           ------------------} var RootPtr : tBSTNodePtr);
{*
** Pomocn procedura pro vyhledn, pesthovn a uvolnn nejpravjho
** uzlu v podstromu urenm ukazatelem RootPtr. Na vstupu se pedpokld
** hodnota ukazatele RootPtr rzn od nil (zajistte to testovnm ped
** voln procedury). Dle se pedpokld, e pomocn ukazatel PtrReplaced
** ukazuje na uzel, kter se m naplnit hodnotami vyhledanho uzlu.
**
**   replace [ri'pleis] = nahradit
**   by [bai] = (km, m)
**   rightmost [raitmoust] = nejpravj
**
** Pomocn ukazatel nazvte ptr.
**}
    var
        ptr: TBSTNodePtr;
    begin
        if RootPtr^.RPtr = nil then begin
            PtrReplaced^.Key := RootPtr^.Key;  {nahrazen kle}
            PtrReplaced^.Cont := RootPtr^.Cont;{nahrazen obsahu}
            ptr := RootPtr;
            RootPtr := ptr^.LPtr;
            Dispose(ptr);
            end {if}
        else
            ReplaceByRightmost(PtrReplaced, RootPtr^.RPtr);
    end;

var
    ptr: TBSTNodePtr;
begin
    if RootPtr <> nil then begin
        if K < RootPtr^.Key then
            BSTDelete(RootPtr^.LPtr, K)
        else if K > RootPtr^.Key then
            BSTDelete(RootPtr^.RPtr, K)
        else begin
            ptr := RootPtr;
            if ptr^.RPtr = nil {prav podstrom przdn} then begin
                RootPtr := ptr^.LPtr; {nahrazen levm podstromem}
                Dispose(ptr);
                end {if}
            else if ptr^.LPtr = nil {lev podstrom przdn} then begin
                RootPtr := ptr^.RPtr; {nahrazen pravm podstromem}
                Dispose(ptr);
                end {else if}
            else {nahrazen nejpravjm uzlem levho podstromu}
                ReplaceByRightmost(RootPtr, ptr^.LPtr);
            end {else};
        end {if};
end;


{*}procedure BSTDispose (var RootPtr:tBSTNodePtr);
{*
** Korektn zru cel binrn vyhledvac strom. Zvolte nejvhodnj
** druh rekurzvnho prchodu stromem. Nedeklarujte dn pomocn procedury
** nebo funkce.
**}
begin
    if RootPtr <> nil {(RootPtr=nil) ukon rekurzivn voln} then begin
        BSTDispose(RootPtr^.LPtr); {uvoln z pamti lev podstrom}
        BSTDispose(RootPtr^.RPtr); {uvoln z pamti prav podstrom}
        Dispose(RootPtr); {uvoln pam؜ obsazenou koenem}
        RootPtr := nil;
        end;
end;


{*Konec p401}
{* p403.pas: **********************************************************}
{* Tma: Vyhledvac tabulka v neseazenm poli se zar. (optimalizace)
**         Prvn implementace: Petr Pikryl, prosinec 1994
**         prava ASInsert podle Vtzslava Samela (XSAMEL00), kvten 1995
**         Oprava ASInsert podle Davida Hladkho (XHLADK01), leden 1996
**         pravy: Petr Pikryl, listopad 1997, kvten 1998
**
** Implementujte vyhledvac tabulku podle nsledujcch poadavk.
** Tabulka je implementovna v poli, obsah prvk pole nen seazen.
** Pi vyhledvn se sekvenn prochz cel vyuit pole s vyuitm
** takzvan zarky. Maximln kapacita tabulky je tedy o jedniku ni,
** ne maximln vyuiteln kapacita pole. Implementujte nsledujc
** procedury a funkce (zkratka AS pochz ze slova Array = pole a
** Sentinel = zde zarka):
**
**   ASInit ..... inicializace tabulky
**   ASSearch ... vyhledvn se zarkou v neseazenm poli
**   ASInsert ... vkldn do neseazenho pole s vyuitm ASSearch
**
** Pi kadm vyhledn se optimalizuje doba vyhledvn asto hledanch
** poloek tm, e se nalezen poloka vdy posunuje o jedno msto smrem
** k zatku pole.
**
** Definici typ naleznete v souboru p403.ifc. Tabulka je reprezentovna
** datovou strukturou typu tASTable, kter se skld z pole 'arr' a indexu
** posledn vyuit poloky pole 'last'. Poloky pole jsou tvoeny zznamy
** typu tASData, ve kterch se nachz sloka Key (klem je pro jednoduchost
** slo typu integer) a obsah Cont (krtk etzec). Pi implementaci tl
** eench procedur uvaujte maximln rozmr pole ASSize (viz poznmka
** v p403.ifc).
**
** Dleitm rysem vyhledvacch metod je poet porovnvn vyhledvanho
** kle s kli prohledvanch poloek pole. K porovnvn vyuvejte
** povinn funkce ASCompare (viz dle). Poet porovnvn omezte
** na minimum. To znamen, e nebudete volat podruh funkci ASCompare
** pro stejn kle tam, kde jste si mohli vsledek porovnn zapamatovat
** v pomocn promnn.
**
** Anglitina:
**      array [@'rei] ... pole (tak ik)
**      search [s@:] ... hledat, ptrat
**
**}
{*}function ASCompare (k1:integer; k2:integer) : integer;
{*          ---------  porovnn dvou kl }
{*}begin
{*}   ASCompNum := ASCompNum+1;           { dal voln funkce ASCompare }
{*}   if      k1<k2 then ASCompare:=-1
{*}   else if k1=k2 then ASCompare:= 0
{*}   else   {k1>k2}     ASCompare:= 1;
{*}end;
{*}
{*}procedure ASError;
{*           ------- }
{*}begin
{*} writeln(fout,' ASError: oeten chyby.');
{*} errflg := true;
{*}end;
{* -------------------------------------------------------------------------}

{*}procedure ASInit (var Tab:tASTable);
{*           ------
{* Inicializace tabulky (vsledkem je przdn tabulka).
**}
begin
    Tab.last := 0;
end;


{*}function ASSearch (var Tab:tASTable; key:integer;
{*          --------} var ind:integer) : boolean;
{*
** Vyhledvn v NESEAZENM poli se zarkou a s pesunem nalezen
** poloky o jednu pozici dopedu (vmna s pedchoz polokou).
**
** Vyhledvacm klem je hodnota key. Funkce vrac pznak, zda byl prvek
** nalezen.  Pokud ne (vrac false), pak se v promnn `ind' vrac prvn
** voln pozice, na kterou se me prvek vloit.
** Pokud byl prvek nalezen (vrac true), dolo k jeho posunut o jednu
** pozici dopedu a v promnn ind se vrac nov pozice nalezenho prvku.
**
** Pro porovnn dvou kl pouvejte peddefinovanou funkci ASCompare
** (viz ve). Vzhledem k tomu, e se pi vyhledvn vdy pouv
** zarka, bude minimln poet porovnn (pi przdn tabulce) roven 1.
**}
var
    b: Boolean;
    pom: TASData;
begin
    with Tab do begin
        arr[last + 1].Key := key; {inicializace zarky}
        ind := 0;
        repeat
            ind := Succ(ind);
            b := ASCompare(key, arr[ind].Key) = 0;
        until b;
        b := ind < last + 1; {pznak nalezen kle}
        if b And (ind > 1) then begin
            pom := arr[ind];
            arr[ind] := arr[ind - 1];
            arr[ind - 1] := pom;
            ind := Pred(ind);
            end {if}
        end {with};
    ASSearch := b;
end;


{*}procedure ASInsert (var Tab:tASTable; Key:integer; Content:string);
{*           --------
** Vlo novou poloku s obsahem Content a klem Key do tabulky Tab.
**
** Pokud by vloenm dal poloky dolo k peplnn Tab (pokud by nelo
** pi dalm vyhledvn uloit zarku), volejte proceduru ASError
** a novou poloku nevkldejte.
**
** Pokud dan poloka (udan klem Key) v poli ji existuje,
** piad se do odpovdajc sloky zznamu nov obsah.
** Pi vyhledvn ji existujc poloky vyuijte dve implementovanou
** funkci ASSearch (to znamen, e se existujc a modifikovan poloka
** automaticky posune dopedu).
**}
var
    ind: Integer;
begin
    with Tab do begin
        if ASSearch(Tab, Key, ind) then
            {kl ji existuje => aktualizace obsahu}
            arr[ind].Cont := Content
        else if ind < ASSize then {vlo novou poloku} begin
            arr[ind].Key := Key;
            arr[ind].Cont := Content;
            last := ind;
            end {else if}
        else {tabulka je ji pln}
            ASError;
        end {with};
end;


{*Konec P403}
{* p404.pas: **********************************************************}
{* Tma: Index-sekvenn vyhledvn v souboru
{*                 Autor:    Karel Obluk (1992)
**                 Upravili: David Kivsk (1992),
**                           Petr Pikryl 1993, prosinec 1994
**                           Petr Pikryl, listopad 1997
**                           Petr Pikryl, kvten 1998
**
** Index-sekvenn vyhledvn v seazenm souboru.
** Zpracovvan binrn soubor obsahuje daje o svtcch se jmnem a datem.
** plnou definici typ naleznete v souboru p404.ifc. Jmno a datum jsou
** v souboru uloeny ve tvaru zznam typu tNameDay se slokami Name a Day
** (krtk etzce).
**
** Pro index-sekvenn vyhledvn je procedurou FMakeIndex vybudovna
** struktura index typu tIndex, kter se skld z pole index 'arr' a
** z indexu poslednho obsazenho prvku v poli 'last'. Prvky pole jsou
** tvoeny zznamy typu tIndItem s polokami Letter:char, kter obsahuje
** poten psmeno jmna, a FPos:longint, kter obsahuje slo zznamu
** (offset) v binrnm souboru.
**
** Funkce FSearch slou k vyhledvn zznamu se zadanm jmnem. Funkce
** vrac datum dne, na kter pipad svtek danho jmna.
**
** Anglitina:
**    offset [ofset] = zde posunut vi zatku
**    make [meik] = vyrobit, sestavit, zhotovit
**    name-day [neim dei] = svtek (ve smyslu dnu v roce ke jmnu)
**    letter [let@] = psmeno, litera
**}

{*}procedure FMakeIndex (var fbin : tNDFile; var Index : tIndex);
{*           ----------
** Binrn soubor 'fbin' je tvoen polokami typu tNameDay, kter obsahuj
** kestn jmno a datum dne, kter na toto jmno pipad. Poloky v souboru
** jsou abecedn seazeny podle jmna.
**
** Procedura FMakeIndex napln strukturu Index podle obsahu souboru fbin
** nsledujcm zpsobem:
**
**  - Pedpokldejte, e soubor fbin je oteven pro ten (nastaveno pro
**    ten prvnho zznamu).
**  - Pi budovn struktury Index budeme soubor fbin prochzet sekvenn.
**  - Pokud narazme na zznam se jmnem, kter zan na dosud neznm
**    psmeno, pidme do struktury Index novou poloku. Poloka zachycuje
**    existenci novho psmene a pozici prvnho zznamu se jmnem, kter
**    tmto psmenem zan.
**
** Pro zjitn pozice v souboru slou funkce FilePos:
**     FilePos(var f) : longint;    (viz help TurboPascalu)
**}
var
    NameDay: TNameDay;
begin
    with Index do begin
        last := 0;
        while not Eof(fbin) do begin
            arr[last + 1].FPos := FilePos(fbin);
            Read(fbin, NameDay);
            arr[last + 1].Letter := NameDay.Name[1];
            if last = 0 then
                last := Succ(last)
            else if arr[last + 1].Letter > arr[last].Letter then
                last := Succ(last);
            end {while};
        end {with};
end;


{*}function FSearch (var fbin:tNDFile; var Index:tIndex;
{*          -------} Name:string; var Date:string):boolean;
{* Hled jmno 'Name' v souboru fbin (je ji oteven pro ten).
** Funkce vyuv struktury index Index (vytvoen procedurou
** FMakeIndex) nsledujcm zpsobem:
**
**  - Zsk prvn psmeno zadanho jmna a sekvenn je vyhled
**    ve struktue Index (je to rychl operace -- u nronjch
**    a rozshlejch aplikac by se vyuilo rychlejho vyhledvn
**    ve struktue Index).
**  - Z vyhledan poloky zskme pozici prvnho zznamu v souboru,
**    ve kterm jmno zan stejnm psmenem.
**  - Nastavme se na urenou pozici v souboru pomoc funkce Seek:
**    Seek(var f; n : longint); (viz help Turbo Pascalu).
**  - Od tohoto msta teme soubor sekvenn a hledme zznam se zadanm
**    jmnem. Sekvenn hledn ukonme v okamiku, kdy se v nsledujcch
**    zznamech (seazeno podle abecedy) jmno u neme vyskytnout.
**  - Pokud je jmno nalezeno, vrac se datum svtku v promnn Date a
**    funkn hodnota true. Pokud jmno nalezeno nen, vrac se funkn
**    hodnota false a hodnota promnn Date je nedefinovan.
**}
var
    NameDay: TNameDay;
    i: Integer;
    b: Boolean;
begin
    i := 1;
    b := False;
    while not b And (i <= MAXINDEX) do begin
        b := Index.arr[i].Letter = Name[1];
        i := Succ(i);
        end {while};
    i := Pred(i);
    if b then begin
        Seek(fbin, Index.arr[i].FPos);
        b := False;
        while not b And not Eof(fbin) do begin
            Read(fbin, NameDay);
            b := NameDay.Name = Name;
            if b then Date := NameDay.Day;
            end {while};
        end {if};
    FSearch := b;
end;


{*Konec P404}
{* p405.pas: **********************************************************}
{* Tma: Rekurzivn implementace slovnkovho vyhledvacho stromu
**                           Vytvoil: Bohuslav Kena, listopad 2000
**                           pravy: Bohuslav Krena, duben 2001
**
** Implementujte rekurzivnm zpsobem zkladn operace nad slovnkovm
** vyhledvacm stromem (v anglitin LST -- Lexical Search Tree).
**
** Pro pouit jsou dleit listy stromu (nemaj dn nslednky),
** kter obsahuj etzce slovnkovho uspodn (slova).
** Nelistov (vnitn) uzly obsahuj pslun prefixy tchto slov.
** Strom je N-rn, tzn. kad uzel m a N nslednk (podstrom).
**
** Slova se skldaj ze znak dan abecedy, jej kardinalita je N.
** Jako mnoinu slov zvolme m-kombinace, tzn. slova jsou neklesajc
** posloupnosti dlky M s monost opakovn znak ve slov.
** Pro jednoduchost budeme pouvat abecedu ['1','2',..'9'], N = 9.
**
** Pklad: 2-kombinace na mnoin [1,2,3] jsou 11, 12, 13, 22, 23, 33.
** Na dal pklady se mete podvat do souboru se vzorovmi vsledky.
** Pro zvolen pklad m vygenerovan strom nsledujc strukturu:
**
**                    ''
**         /           |     \
**       '1'          '2'    '3'
**   /    |   \      /   \    |
** '11' '12' '13'  '22' '23' '33'
**
**
** Rekurzivnm zpsobem ete nsledujc procedury a funkce:
**
**   LST_Init ......... inicializace vyhledvacho stromu
**   LST_Create ....... vytvoen vyhledvacho stromu
**   LST_Dispose ...... zruen celho stromu
**   LST_OutLeaves .... vypsn slov slovnkovho uspodn (list)
**   LST_Leaves ....... zjitn potu slov (list)
**   LST_Contain ...... hledn slova ve stromu (v listech)
**
** Pesnou definici typ naleznete v souboru p405.ifc; pro pehled --
** ADT LST je reprezentovn koenovm ukazatelem stromu typu tLSTPtr.
** Uzel stromu (zznam typu tLSTNode) obsahuje pole ukazatel tLSTPtrArr
** (ukazatele jsou typutLSTPtr) a sloku Key: string -- tedy slovo
** nebo prefix slova slovnkovho uspodn.
**
** Poznmka: nepouvejte nestandardn pkazy (exit,...) a operace.
** Vdy uvaujte pln vyhodnocovn logickch vraz.
** Nepouvejte pepnae kompiltoru.
**
** Je poadovno obecn een. Nevyuvejte proto dn implementan
** zjednoduen prchodu stromem plynouc z toho, e prvky abecedy
** odpovdaj svm indexm (tzn. e nap. na pozici 1 je znak '1').
** Vae een by mlo sprvn pracovat i pro jinou abecedu.
**
** Anglitina:
**       lexical [leksikl] = slovn, slovnkov
**       search [s@:] = vyhledvat, vyhledvac
**       tree [tri:] = strom
**       leaf [li:f] = list
**       pointer (Ptr) [pointr] = ukazatel
**       root [ru:t] = koen
**       node [noud] = uzel
**       key [ki:] = kl
**       insert [in's@:t] = vloit
**       create [kri@jt] = vytvoit
**       dispose [dis'pouz] = zruit
**       contain [k@n'tejn] = obsahovat
**}

{*}procedure LST_Init (var Root:tLSTPtr);
{*           --------
** Poten inicializace stromu ped prvnm pouitm datov struktury.
** Poten testovn ukazatele nen mon, protoe obsahuje nedefinovanou
** (tj. libovolnou) hodnotu, kter ovem neodr reln stav.
**}
begin
    Root := nil;
end;


{*}procedure LST_Create(var Root:tLSTPtr; M, maxN:integer);
{*           ----------
** Vytvo nov slovnkov vyhledvac strom podle poadavk.
** M udv dlku slov, kter maj bt generovna. slo maxN udv
** kardinalitu abecedy (tj. i slo poslednho prvku). Pokud uivatel
** zad kardinalitu vt, ne je maximln dovolen kardinalita,
** procedura nevype dnou chybu, ale chov se jako by byla
** zadna maximln kardinalita.
**
** Strom vytvejte rekurzivn pomoc procedury LSTCreate.
** V tle hlavn procedury bude pouze oeten kardinality
** a voln pomocn procedury se sprvnmi parametry.
** Ostatn programov kd bude uvnit pomocn procedury LSTCreate.
**
** Strom vytvejte tak, aby podstromy byly uspodny podle pirozenho
** podku -- podle abecedy, vlevo nejmen. Tato procedura je klov
** pro cel ADT. Bez n nem cenu dal operace implementovat.
**
** Mete pedpokldat, e procedura LST_Create je volna pouze
** na inicializovan strom (tedy ne na neinicializovan strom
** ani na ji vytvoen strom).
**}

{*}procedure LSTCreate(var Root:tLSTPtr; M, minN, maxN:integer; PreKey:String);
{*           ---------
** Pomocn procedura, kter rekurzivn vytvo podstrom specifikovan
** parametry s nsledujcm vznamem:
**
** Root .... ukazatel na kter se nave vytven podstrom
** M ....... zbvajc dlka do pln dlky slova (indiktor zastaven rekurze)
** minN .... slo prvnho pouitelnho znaku abecedy
** maxN .... slo poslednho pouitelnho znaku abecedy
** PreKey .. doposud vygenerovan etzec - prefix spolen pro vechna slova
**           generovanho podstromu
**}
var
    i: Integer;
begin
    New(Root);
    with Root^ do begin
        Key := PreKey;
        for i := 1 to LSTmaxN do begin
            if (M > 0) And (i <= maxN - minN + 1) then
                LSTCreate(SubTree[i],
                          M - 1, minN + i - 1, maxN,
                          PreKey + LSTalpha[minN + i - 1])
            else
                SubTree[i] := nil;
            end {for};
        end {with};
end;


begin
    if maxN > LSTmaxN then maxN := LSTmaxN;
    LSTCreate(Root, M, 1, maxN, '');
end;


{*}procedure LST_Dispose(var Root: tLSTPtr);
{*           -----------
** Korektn zru cel slovnkov vyhledvac strom. Zvolte nejvhodnj
** druh rekurzvnho prchodu stromem. Nedeklarujte dn pomocn procedury
** nebo funkce.
**
** Po zruen stromu se strom bude nachzet ve stejnm stavu jako
** se nachzel po inicializaci.
**
** Nevytvejte dn sloit konstrukce - pro implementaci sta 5 pkaz.
**}
var
    i: Integer;
begin
    if Root <> nil then begin
        for i := 1 to LSTmaxN do LST_Dispose(Root^.SubTree[i]);
        Dispose(Root);
        Root := nil;
        end {if};
end;


{*}procedure LST_OutLeaves(var Root: tLSTPtr; var fout: text);
{*           ------------
** Vype vechna slova (z list) v pirozenm poad.
**
** Mezi slova vlote jednu mezeru. Po vypsn vech slov pod vnitnm
** uzlem nejni rovn vlote na vstup jeden przdn dek.
** Nen-li vm to jasn, podvejte se do vzorovch vsledk.
**
** Przdn strom (po inicializaci) neobsahuje dn slovo.
**}
var
    i: Integer;
begin
    if Root <> nil then
        with Root^ do begin
            if SubTree[1] = nil {uzel je listem} then
                Write(fout, Key, ' ')
            else begin
                for i := 1 to LSTmaxN do
                    LST_OutLeaves(SubTree[i], fout);
                if SubTree[1]^.SubTree[1] = nil then WriteLn(fout);
                end {else};
            end {with};
end;


{*}function LST_Leaves(var Root: tLSTPtr) : integer;
{*          ---------
** Spot poet slov (list) rekurzivnm prchodem stromu.
** Poznmka: Przdn strom m nulov poet list.
**}
var
    i, Result: Integer;
begin
    Result := 0;
    if Root <> nil then
        with Root^ do begin
            if SubTree[1] = nil {uzel je listem} then
                Result := Succ(Result)
            else
                for i := 1 to LSTmaxN do
                    Result := Result + LST_Leaves(SubTree[i]);
            end {with};
    LST_Leaves := Result;
end;


{*}function LST_Contain(var Root:tLSTPtr; SKey: string) : boolean;
{*          -----------
** Zjist efektivnm zpsobem, zda strom obsahuje zadan kl (slovo).
** Anglitina: SKey = Searched Key = hledan kl.
**
** Nalezen kle ve vnitnch uzlech stromu se nepovauje za nalezen
** kle ve stromu.
**
** Pi hledn vyuvejte informace obsaen v uzlech (prefixy slov).
** Nen pijateln prchod celm stromem.
**}
var
    i: Integer;
    Result: Boolean;
begin
    Result := False;
    if Root <> nil then
        with Root^ do begin
            if SubTree[1] = nil {uzel je listem} then
                Result := Key = SKey
            else if Key = Copy(SKey, 1, Length(Key)) then begin
                i := 1;
                while not Result And (i <= LSTmaxN) do begin
                    Result := LST_Contain(SubTree[i], SKey);
                    i := Succ(i);
                    end {while};
                end {else if};
            end {with};
    LST_Contain := Result;
end;


{*Konec p405}
